; Cross Platform Music Player
; KSS version
; /Mic, 2008-2009


; Define the starting address of XPMP's RAM chunk 
.IFNDEF XPMP_RAM_START
.DEFINE XPMP_RAM_START $C000
.ENDIF

.DEFINE XPMP_SN_PORT $7F
.DEFINE XPMP_AY_ADDR $A0
.DEFINE XPMP_AY_DATA $A1

.IFDEF XPMP_USES_SN76489
.DEFINE XPMP_ENABLE_CHANNEL_A
.DEFINE XPMP_ENABLE_CHANNEL_B
.DEFINE XPMP_ENABLE_CHANNEL_C
.DEFINE XPMP_ENABLE_CHANNEL_D
.ENDIF
.IFDEF XPMP_USES_AY
.DEFINE XPMP_ENABLE_CHANNEL_E
.DEFINE XPMP_ENABLE_CHANNEL_F
.DEFINE XPMP_ENABLE_CHANNEL_G
.ENDIF
.IFDEF XPMP_USES_SCC
.DEFINE XPMP_ENABLE_CHANNEL_H
.DEFINE XPMP_ENABLE_CHANNEL_I
.DEFINE XPMP_ENABLE_CHANNEL_J
.DEFINE XPMP_ENABLE_CHANNEL_K
.ENDIF

.EQU CMD_NOTE   $00
.EQU CMD_REST	$0C
.EQU CMD_OCTAVE $10
.EQU CMD_DUTY   $20
.EQU CMD_VOL2   $30
.EQU CMD_OCTUP  $40
.EQU CMD_OCTDN  $50
.EQU CMD_NOTE2	$60
.EQU CMD_ARPOFF $90
.EQU CMD_JSR	$96
.EQU CMD_RTS	$97
.EQU CMD_HWES	$98
.EQU CMD_HWNS	$99
.EQU CMD_LEN	$9A
.EQU CMD_CBOFF  $E0
.EQU CMD_CBONCE $E1
.EQU CMD_CBEVNT $E2
.EQU CMD_CBEVVC $E3
.EQU CMD_CBEVVM $E4
.EQU CMD_CBEVOC $E5
.EQU CMD_HWTE	$E8
.EQU CMD_LDWAVE $EC
.EQU CMD_DETUNE $ED
.EQU CMD_VOLSET $F0
.EQU CMD_VOLMAC $F1
.EQU CMD_DUTMAC $F2
.EQU CMD_PORMAC $F3
.EQU CMD_PANMAC $F4
.EQU CMD_VIBMAC $F5
.EQU CMD_SWPMAC $F6
.EQU CMD_VSLMAC $F7
.EQU CMD_ARPMAC $F8
.EQU CMD_JMP    $F9
.EQU CMD_DJNZ   $FA
.EQU CMD_LOPCNT $FB
.EQU CMD_APMAC2 $FC
.EQU CMD_END    $FF

.EQU EFFECT_DISABLED 0


; 59 bytes
.STRUCT xpmp_channel_t
dataPtr		dw
dataPos		dw
delay		dw
delayHi		db	;+6
note		db	;+7
noteOffs	db
octave		db	;+9
duty		db
freq		dw
volume		db	;+13
volOffs		db
enven		db	;+15	on/off setting
freqOffs	dw	;+16
freqOffsLatch	dw
detune		dw 
vMac		db	;+22
vMacPtr		dw
vMacPos		db
enMac		db	;+26
enMacPtr	dw
enMacPos	db
en2Mac		db	;+30
en2MacPtr	dw
en2MacPos	db
epMac		db	;+34
epMacPtr	dw
epMacPos	db
mpMac		db	;+38
mpMacPtr	dw
mpMacDelay	db
loop1		db	;+42
loop2		db
loopPtr		dw	;+44
cbEvnote	dw	;+46
returnAddr	dw	;+48
oldPos		dw	;+50
delayLatch	dw	;+52
delayLatch2	db	;+54
csMac		db
csMacPtr	dw
csMacPos	db
.ENDST


.STRUCT xpmp_fm_channel_t
dataPtr		dw
dataPos		dw
delay		dw
delayHi		db	; Note delays are 24 bit unsigned fixed point in 16.8 format
note		db
noteOffs	db
octave		db
duty		db
freq		dw
volume		db
volOffs		db
volOffsLatch	db
freqOffs	dw
freqOffsLatch	dw
detune		dw 
vMac		db
vMacPtr		dw
vMacPos		db
enMac		db
enMacPtr	dw
enMacPos	db
en2Mac		db
en2MacPtr	dw
en2MacPos	db
epMac		db
epMacPtr	dw
epMacPos	db
csMac		db
csMacPtr	dw
csMacPos	db
mpMac		db
mpMacPtr	dw
mpMacDelay	db
loop1		db
loop2		db
loopPtr		dw
returnAddr	dw
oldPos		dw
algo		db
cbEvnote	dw
.ENDST


.ENUM XPMP_RAM_START
xpmp_channel0	INSTANCEOF xpmp_channel_t	; SN76489
xpmp_channel1 	INSTANCEOF xpmp_channel_t
xpmp_channel2 	INSTANCEOF xpmp_channel_t
xpmp_channel3 	INSTANCEOF xpmp_channel_t
xpmp_channel4 	INSTANCEOF xpmp_channel_t	; AY3-8910
xpmp_channel5 	INSTANCEOF xpmp_channel_t
xpmp_channel6 	INSTANCEOF xpmp_channel_t
xpmp_channel7 	INSTANCEOF xpmp_channel_t	; Konami SCC
xpmp_channel8 	INSTANCEOF xpmp_channel_t
xpmp_channel9 	INSTANCEOF xpmp_channel_t
xpmp_channel10 	INSTANCEOF xpmp_channel_t
xpmp_freqChange	db
xpmp_volChange 	db
xpmp_lastNote	db
xpmp_pan	db
xpmp_chnum	db
xpmp_ayen	db
xpmp_tempw	dw
.ENDE

; Compare HL with an immediate 16-bit number and jump if less (unsigned)
.MACRO JL_IMM16
	push	hl
	ld	de,\1
	and	a
	sbc	hl,de
	pop	hl
	jp	c,\2
.ENDM


; Compare HL with an immediate 16-bit number and jump if greater or equal (unsigned)
.MACRO JGE_IMM16
	push	hl
	ld	de,\1
	and	a
	sbc	hl,de
	pop	hl
	jp	nc,\2
.ENDM



; Initialize the music player
; HL = pointer to song table, A = song number
xpmp_init:
	ld	b,0
	dec	a
	ld	c,a
	sla	c
	add	hl,bc
	
	; Initialize all the player variables to zero
	ld 	bc,XPMP_RAM_START
	ld 	a,0
	ld 	de,xpmp_tempw+2-XPMP_RAM_START
	xpmp_init_zero:
		ld	a,0
		ld 	(bc),a
		inc 	bc
		dec 	de
		ld	a,d
		or	e
		jr 	nz,xpmp_init_zero

	; Initialize channel data pointers
	.IFDEF XPMP_ENABLE_CHANNEL_A
	ld	a,(hl)
	ld	(xpmp_channel0.dataPtr),a
	.ENDIF
	inc	hl
	.IFDEF XPMP_ENABLE_CHANNEL_A
	ld	a,(hl)
	ld	(xpmp_channel0.dataPtr+1),a
	.ENDIF
	inc	hl
	.IFDEF XPMP_ENABLE_CHANNEL_B
	ld	a,(hl)
	ld	(xpmp_channel1.dataPtr),a
	.ENDIF
	inc	hl
	.IFDEF XPMP_ENABLE_CHANNEL_B
	ld	a,(hl)
	ld	(xpmp_channel1.dataPtr+1),a
	.ENDIF
	inc	hl
	.IFDEF XPMP_ENABLE_CHANNEL_C
	ld	a,(hl)
	ld	(xpmp_channel2.dataPtr),a
	.ENDIF
	inc	hl
	.IFDEF XPMP_ENABLE_CHANNEL_C
	ld	a,(hl)
	ld	(xpmp_channel2.dataPtr+1),a
	.ENDIF
	inc	hl
	.IFDEF XPMP_ENABLE_CHANNEL_D
	ld	a,(hl)
	ld	(xpmp_channel3.dataPtr),a
	.ENDIF
	inc	hl
	.IFDEF XPMP_ENABLE_CHANNEL_D
	ld	a,(hl)
	ld	(xpmp_channel3.dataPtr+1),a
	.ENDIF
	inc	hl

	.IFDEF XPMP_ENABLE_CHANNEL_E
	ld	a,(hl)
	ld	(xpmp_channel4.dataPtr),a
	.ENDIF
	inc	hl
	.IFDEF XPMP_ENABLE_CHANNEL_E
	ld	a,(hl)
	ld	(xpmp_channel4.dataPtr+1),a
	.ENDIF
	inc	hl
	.IFDEF XPMP_ENABLE_CHANNEL_F
	ld	a,(hl)
	ld	(xpmp_channel5.dataPtr),a
	.ENDIF
	inc	hl
	.IFDEF XPMP_ENABLE_CHANNEL_F
	ld	a,(hl)
	ld	(xpmp_channel5.dataPtr+1),a
	.ENDIF
	inc	hl
	.IFDEF XPMP_ENABLE_CHANNEL_G
	ld	a,(hl)
	ld	(xpmp_channel6.dataPtr),a
	.ENDIF
	inc	hl
	.IFDEF XPMP_ENABLE_CHANNEL_G
	ld	a,(hl)
	ld	(xpmp_channel6.dataPtr+1),a
	.ENDIF
	inc	hl

	.IFDEF XPMP_ENABLE_CHANNEL_H
	ld	a,(hl)
	ld	(xpmp_channel7.dataPtr),a
	.ENDIF
	inc	hl
	.IFDEF XPMP_ENABLE_CHANNEL_H
	ld	a,(hl)
	ld	(xpmp_channel7.dataPtr+1),a
	.ENDIF
	inc	hl
	.IFDEF XPMP_ENABLE_CHANNEL_I
	ld	a,(hl)
	ld	(xpmp_channel8.dataPtr),a
	.ENDIF
	inc	hl
	.IFDEF XPMP_ENABLE_CHANNEL_I
	ld	a,(hl)
	ld	(xpmp_channel8.dataPtr+1),a
	.ENDIF
	inc	hl
	.IFDEF XPMP_ENABLE_CHANNEL_J
	ld	a,(hl)
	ld	(xpmp_channel9.dataPtr),a
	.ENDIF
	inc	hl
	.IFDEF XPMP_ENABLE_CHANNEL_J
	ld	a,(hl)
	ld	(xpmp_channel9.dataPtr+1),a
	.ENDIF
	inc	hl
	.IFDEF XPMP_ENABLE_CHANNEL_K
	ld	a,(hl)
	ld	(xpmp_channel10.dataPtr),a
	.ENDIF
	inc	hl
	.IFDEF XPMP_ENABLE_CHANNEL_K
	ld	a,(hl)
	ld	(xpmp_channel10.dataPtr+1),a
	.ENDIF
	inc	hl
	
	.IFDEF XPMP_ENABLE_CHANNEL_A
	ld	hl,xpmp_channel0.loop1-1
	ld	(xpmp_channel0.loopPtr),hl
	.ENDIF
	.IFDEF XPMP_ENABLE_CHANNEL_B
	ld	hl,xpmp_channel1.loop1-1
	ld	(xpmp_channel1.loopPtr),hl
	.ENDIF
	.IFDEF XPMP_ENABLE_CHANNEL_C
	ld	hl,xpmp_channel2.loop1-1
	ld	(xpmp_channel2.loopPtr),hl
	.ENDIF
	.IFDEF XPMP_ENABLE_CHANNEL_D
	ld	hl,xpmp_channel3.loop1-1
	ld	(xpmp_channel3.loopPtr),hl
	.ENDIF

	.IFDEF XPMP_ENABLE_CHANNEL_E
	ld	hl,xpmp_channel4.loop1-1
	ld	(xpmp_channel4.loopPtr),hl
	.ENDIF
	.IFDEF XPMP_ENABLE_CHANNEL_F
	ld	hl,xpmp_channel5.loop1-1
	ld	(xpmp_channel5.loopPtr),hl
	.ENDIF
	.IFDEF XPMP_ENABLE_CHANNEL_G
	ld	hl,xpmp_channel6.loop1-1
	ld	(xpmp_channel6.loopPtr),hl
	.ENDIF
	
	.IFDEF XPMP_ENABLE_CHANNEL_H
	ld	hl,xpmp_channel7.loop1-1
	ld	(xpmp_channel7.loopPtr),hl
	.ENDIF
	.IFDEF XPMP_ENABLE_CHANNEL_I
	ld	hl,xpmp_channel8.loop1-1
	ld	(xpmp_channel8.loopPtr),hl
	.ENDIF
	.IFDEF XPMP_ENABLE_CHANNEL_J
	ld	hl,xpmp_channel9.loop1-1
	ld	(xpmp_channel9.loopPtr),hl
	.ENDIF
	.IFDEF XPMP_ENABLE_CHANNEL_K
	ld	hl,xpmp_channel10.loop1-1
	ld	(xpmp_channel10.loopPtr),hl
	.ENDIF
	
	; Initialize the delays for all channels to 1
	ld 	a,1
	.IFDEF XPMP_ENABLE_CHANNEL_A
	ld	(xpmp_channel0.delay+1),a
	.ENDIF
	.IFDEF XPMP_ENABLE_CHANNEL_B
	ld	(xpmp_channel1.delay+1),a
	.ENDIF
	.IFDEF XPMP_ENABLE_CHANNEL_C
	ld	(xpmp_channel2.delay+1),a
	.ENDIF
	.IFDEF XPMP_ENABLE_CHANNEL_D
	ld	(xpmp_channel3.delay+1),a
	.ENDIF
	.IFDEF XPMP_ENABLE_CHANNEL_E
	ld	(xpmp_channel4.delay+1),a
	.ENDIF
	.IFDEF XPMP_ENABLE_CHANNEL_F
	ld	(xpmp_channel5.delay+1),a
	.ENDIF
	.IFDEF XPMP_ENABLE_CHANNEL_G
	ld	(xpmp_channel6.delay+1),a
	.ENDIF
	.IFDEF XPMP_ENABLE_CHANNEL_H
	ld	(xpmp_channel7.delay+1),a
	.ENDIF
	.IFDEF XPMP_ENABLE_CHANNEL_I
	ld	(xpmp_channel8.delay+1),a
	.ENDIF
	.IFDEF XPMP_ENABLE_CHANNEL_J
	ld	(xpmp_channel9.delay+1),a
	.ENDIF
	.IFDEF XPMP_ENABLE_CHANNEL_K
	ld	(xpmp_channel10.delay+1),a
	.ENDIF
	
	; Generate white noise by default
	ld	a,4
	.IFDEF XPMP_ENABLE_CHANNEL_D
	ld	(xpmp_channel3.duty),a
	.ENDIF
	
	.IFDEF XPMP_USES_SCC
	ld	a,$3F
	ld	($9000),a
	ld	a,0
	ld	($988A),a
	ld	($988B),a
	ld	($988C),a
	ld	($988D),a
	ld	($988E),a
	ld	a,$0F
	ld	($988F),a
	.ENDIF
	
	ld	a,$FF
	ld	(xpmp_pan),a
	
	ld	a,$FF
	ld	(xpmp_ayen),a
	
	ret


.macro XPMP_COMMANDS

; Note / rest
xpmp_\1_cmd_00:
xpmp_\1_cmd_60:
	ld	hl,(xpmp_tempw)
xpmp_\1_cmd_00_2:
	ld	a,(xpmp_channel\1.note)
	ld	(xpmp_lastNote),a
	ld	a,c
	and	$0F
	ld	(xpmp_channel\1.note),a
	ld	a,c
	and	$F0
	cp	CMD_NOTE2
	jr	z,xpmp_\1_cmd_00_std_delay
	ld	de,(xpmp_channel\1.dataPos)
	inc	de
	inc	de
	ld	(xpmp_channel\1.dataPos),de
	inc	hl
	ld	a,(hl)
	bit	7,a
	jr	z,xpmp_\1_cmd_00_short_note
		inc	de
		ld	(xpmp_channel\1.dataPos),de
		inc	hl
		res	7,a
		ld	d,a
		srl	d
		rrc	a
		and	$80
		ld	e,(hl)
		or	e
		ld	e,a
		inc	hl
		ld	a,(xpmp_channel\1.delay)	
		add	a,(hl)
		ld	(xpmp_channel\1.delay),a	; Fractional part
		ld	hl,0 
		adc	hl,de
		ld	(xpmp_channel\1.delay+1),hl	; Whole part
		jp 	xpmp_\1_cmd_00_got_delay
	xpmp_\1_cmd_00_short_note:
	ld	d,0
	ld	e,a
	inc	hl
	ld	a,(xpmp_channel\1.delay)	
	add	a,(hl)
	ld	(xpmp_channel\1.delay),a	; Fractional part
	ld	hl,0 
	adc	hl,de
	ret	z
	ld	(xpmp_channel\1.delay+1),hl	; Whole part
	jp 	xpmp_\1_cmd_00_got_delay
	xpmp_\1_cmd_00_std_delay:		; Use delay set by last CMD_LEN
	ld	a,(xpmp_channel\1.delayLatch)
	ld	b,a
	ld	a,(xpmp_channel\1.delay)
	add	a,b
	ld	(xpmp_channel\1.delay),a
	ld 	hl,(xpmp_channel\1.delayLatch+1)
	ld	de,0
	adc	hl,de
	ret	z
	ld	(xpmp_channel\1.delay+1),hl
	xpmp_\1_cmd_00_got_delay:
	ld	a,2
	ld	(xpmp_freqChange),a
	;xpmp_\1_cmd_00_zero_delay:
	ld	a,(xpmp_channel\1.note)
	cp	CMD_REST	
	ret	z				; If this was a rest command we can return now
	.IFNDEF XPMP_VMAC_NOT_USED
	ld	a,(xpmp_channel\1.vMac)
	cp	EFFECT_DISABLED
	call	nz,xpmp_\1_reset_v_mac		; Reset effects as needed..
	.ENDIF
	.IFNDEF XPMP_ENMAC_NOT_USED
	.IFDEF XPMP_CHN\1_USES_EN
	ld	a,(xpmp_channel\1.enMac)
	cp	EFFECT_DISABLED
	call	nz,xpmp_\1_reset_en_mac
	.ENDIF
	.ENDIF
	.IFNDEF XPMP_EN2MAC_NOT_USED
	.IFDEF XPMP_CHN\1_USES_EN2
	ld	a,(xpmp_channel\1.en2Mac)
	cp	EFFECT_DISABLED
	call	nz,xpmp_\1_reset_en2_mac
	.ENDIF
	.ENDIF
	.IF \1 < 3
	.IFNDEF XPMP_MPMAC_NOT_USED
	.IFDEF XPMP_CHN\1_USES_MP
	ld	a,(xpmp_channel\1.mpMac)
	cp	EFFECT_DISABLED
	call	nz,xpmp_\1_reset_mp_mac
	.ENDIF
	.ENDIF
	.IFNDEF XPMP_EPMAC_NOT_USED
	.IFDEF XPMP_CHN\1_USES_EP
	ld	a,(xpmp_channel\1.epMac)
	cp	EFFECT_DISABLED
	call	nz,xpmp_\1_reset_ep_mac
	.ENDIF
	.ENDIF
	.ENDIF
	;.IFDEF XPMP_GAME_GEAR
	ld	a,(xpmp_channel\1.csMac)
	cp	EFFECT_DISABLED
	call	nz,xpmp_\1_reset_cs_mac
	;.ENDIF	
	ld	hl,(xpmp_channel\1.cbEvnote)
	ld	a,h
	or	l
	ret	z
	jp	(hl)				; If a callback has been set for EVERY-NOTE we call it now

; Set octave
xpmp_\1_cmd_10:
	;ld	hl,(xpmp_tempw)
	ld	a,c 
	and	$0F
	sub	2				; Minimum octave is 2
	ld	b,a
	add	a,a
	add	a,a
	sla	b
	sla	b
	sla	b
	add	a,b				; A = (C & $0F) * 12
	ld	(xpmp_channel\1.octave),a
	ret
	
xpmp_\1_cmd_20:
	.IF \1 == 3
	ld	hl,(xpmp_tempw)
	ld	a,c
	and	1
	xor	1
	add	a,a
	add	a,a
	ld	(xpmp_channel\1.duty),a
	.ENDIF
	ret

; Set volume (short)
xpmp_\1_cmd_30:
	;ld	hl,(xpmp_tempw)
	ld	a,c
	and	$0F
	ld	(xpmp_channel\1.volume),a
	ld	a,1
	ld	(xpmp_volChange),a		; Volume has changed
	ld	a,EFFECT_DISABLED
	ld	(xpmp_channel\1.vMac),a		; Volume set overrides volume macros
	ret

; Octave up + note	
xpmp_\1_cmd_40:
	ld	hl,(xpmp_tempw)
	ld	a,(xpmp_channel\1.octave)
	add	a,12
	ld	(xpmp_channel\1.octave),a
	jp	xpmp_\1_cmd_00_2

; Octave down + note
xpmp_\1_cmd_50:
	ld	hl,(xpmp_tempw)
	ld	a,(xpmp_channel\1.octave)
	sub	12
	ld	(xpmp_channel\1.octave),a
	jp	xpmp_\1_cmd_00_2

;xpmp_\1_cmd_60:
	;ld	hl,(xpmp_tempw)
;	ret
xpmp_\1_cmd_70:
	;ld	hl,(xpmp_tempw)
;	ret
xpmp_\1_cmd_80:
	;ld	hl,(xpmp_tempw)
	ret

; Turn off arpeggio macro
xpmp_\1_cmd_90:
	ld	a,c
	cp	CMD_JSR
	jr	z,xpmp_\1_cmd_90_jsr
	cp	CMD_RTS
	jr	z,xpmp_\1_cmd_90_rts
	cp	CMD_LEN
	jr	z,xpmp_\1_cmd_90_len
	
	ld	hl,(xpmp_tempw)
	ld	a,0
	ld	(xpmp_channel\1.enMac),a
	ld	(xpmp_channel\1.en2Mac),a
	ld	(xpmp_channel\1.noteOffs),a
	ret

	xpmp_\1_cmd_90_jsr:
	ld	de,(xpmp_channel\1.dataPos)
	inc	de
	ld	(xpmp_channel\1.oldPos),de
	ld	de,(xpmp_channel\1.dataPtr)
	ld	(xpmp_channel\1.returnAddr),de
	ld	hl,(xpmp_tempw)
	inc	hl
	ld	a,(hl)
	ld	de,xpmp_pattern_tbl
	ld	h,0
	add	a,a
	ld	l,a
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	ld	(xpmp_channel\1.dataPtr),de
	ld	a,$FF
	ld	(xpmp_channel\1.dataPos),a
	ld	(xpmp_channel\1.dataPos+1),a
	ret
	
	xpmp_\1_cmd_90_rts:
	ld	de,(xpmp_channel\1.returnAddr)
	ld	(xpmp_channel\1.dataPtr),de
	ld	de,(xpmp_channel\1.oldPos)
	ld	(xpmp_channel\1.dataPos),de
	ret
	
	xpmp_\1_cmd_90_len:
	ld	hl,(xpmp_tempw)
	ld	de,(xpmp_channel\1.dataPos)
	inc	de
	inc	de
	ld	(xpmp_channel\1.dataPos),de
	inc	hl
	ld	a,(hl)
	bit	7,a
	jr	z,xpmp_\1_cmd_90_short_delay
		inc	de
		ld	(xpmp_channel\1.dataPos),de
		inc	hl
		res	7,a
		ld	d,a
		srl	d
		rrc	a
		and	$80
		ld	e,(hl)
		or	e
		ld	e,a
		inc	hl
		;ld	a,(xpmp_channel\1.delayLatch)	
		;add	a,(hl)
		ld	a,(hl)
		ld	(xpmp_channel\1.delayLatch),a		; Fractional part
		;ld	hl,0 
		;adc	hl,de
		ld	(xpmp_channel\1.delayLatch+1),de	; Whole part
		ret
	xpmp_\1_cmd_90_short_delay:
	ld	d,0
	ld	e,a
	inc	hl
	ld	a,(hl)
	ld	(xpmp_channel\1.delayLatch),a		; Fractional part
	ld	(xpmp_channel\1.delayLatch+1),de	; Whole part
	ret
	
xpmp_\1_cmd_A0:
xpmp_\1_cmd_B0:
xpmp_\1_cmd_C0:
xpmp_\1_cmd_D0:
	ret

; Callback
xpmp_\1_cmd_E0:
	ld	hl,(xpmp_tempw)
	ld	de,(xpmp_channel\1.dataPos)
	inc	de
	ld	(xpmp_channel\1.dataPos),de
	ld	a,c
	cp	CMD_CBOFF
	jr	z,xpmp_\1_cmd_E0_cboff
	cp	CMD_CBONCE
	jr	z,xpmp_\1_cmd_E0_cbonce
	cp	CMD_CBEVNT
	jr	z,xpmp_\1_cmd_E0_cbevnt
	.IF \1 < 3
	cp	CMD_DETUNE
	jr	z,xpmp_\1_cmd_E0_detune
	.ENDIF
	ret
	
	xpmp_\1_cmd_E0_cboff:
	ld	a,0
	ld	(xpmp_channel\1.cbEvnote),a
	ld	(xpmp_channel\1.cbEvnote+1),a
	ret
	
	xpmp_\1_cmd_E0_cbonce:
	inc	hl
	ld	a,(hl)
	ld	de,xpmp_callback_tbl
	ld	h,0
	add	a,a
	ld	l,a
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	ex	de,hl
	jp	(hl)
	
	; Every note
	xpmp_\1_cmd_E0_cbevnt:
	inc	hl
	ld	a,(hl)
	ld	de,xpmp_callback_tbl
	ld	h,0
	add	a,a
	ld	l,a
	add	hl,de
	ld	a,(hl)
	ld	(xpmp_channel\1.cbEvnote),a
	inc	hl
	ld	a,(hl)
	ld	(xpmp_channel\1.cbEvnote+1),a
	ret

	.IF \1 < 3
	xpmp_\1_cmd_E0_detune:
	inc	hl
	ld	e,(hl)
	ld	d,0
	bit	7,e
	jr	z,xpmp_\1_cmd_E0_detune_pos
	ld	d,$FF
	xpmp_\1_cmd_E0_detune_pos:
	ld	(xpmp_channel\1.detune),de
	ret
	.ENDIF
	
xpmp_\1_cmd_F0:
	ld	hl,(xpmp_tempw)
	; Initialize volume macro	
	ld	a,c

	.IFNDEF XPMP_VMAC_NOT_USED
	cp	CMD_VOLMAC
	.IF \1 < 3
	jr	nz,xpmp_\1_cmd_F0_check_VIBMAC
	.ELSE
	jr	nz,xpmp_\1_cmd_F0_check_JMP
	.ENDIF
	inc	hl
	ld	de,(xpmp_channel\1.dataPos)
	inc	de
	ld	a,(hl)
	ld	(xpmp_channel\1.vMac),a
	ld	(xpmp_channel\1.dataPos),de
	xpmp_\1_reset_v_mac:
	dec	a
	add	a,a
	ld	hl,xpmp_v_mac_tbl
	ld	d,0
	ld	e,a
	add	hl,de
	ld	a,(hl)	
	ld	(xpmp_channel\1.vMacPtr),a
	inc	hl
	ld	a,(hl)
	ld	(xpmp_channel\1.vMacPtr+1),a
	ld	hl,(xpmp_channel\1.vMacPtr)
	ld	a,(hl)
	ld	(xpmp_channel\1.volume),a
	ld	a,1
	ld	(xpmp_volChange),a	
	ld	a,1
	ld	(xpmp_channel\1.vMacPos),a
	ret
	.ENDIF
	
	.IF \1 < 3
	xpmp_\1_cmd_F0_check_VIBMAC:
	.IFNDEF XPMP_MPMAC_NOT_USED
	.IFDEF XPMP_CHN\1_USES_MP
	; Initialize vibrato macro
	cp	CMD_VIBMAC
	jr	nz,xpmp_\1_cmd_F0_check_SWPMAC
	ld	de,(xpmp_channel\1.dataPos)
	inc	de
	ld	(xpmp_channel\1.dataPos),de	
	inc	hl
	ld	a,(hl)
	cp	EFFECT_DISABLED
	jr	z,xpmp_\1_cmd_F0_disable_VIBMAC
	ld	(xpmp_channel\1.mpMac),a
	xpmp_\1_reset_mp_mac:
	dec	a
	add	a,a
	ld	hl,xpmp_MP_mac_tbl
	ld	d,0
	ld	e,a
	add	hl,de
	ld	a,(hl)
	ld	(xpmp_channel\1.mpMacPtr),a
	inc	hl
	ld	a,(hl)
	ld	(xpmp_channel\1.mpMacPtr+1),a
	ld	hl,(xpmp_channel\1.mpMacPtr)
	ld	a,(hl)
	ld	(xpmp_channel\1.mpMacDelay),a
	inc	hl
	ld	(xpmp_channel\1.mpMacPtr),hl
	inc	hl
	ld	a,(hl)
	ld	(xpmp_channel\1.freqOffsLatch),a
	ld	a,0
	ld	(xpmp_channel\1.freqOffsLatch+1),a
	ld	(xpmp_channel\1.freqOffs),a
	ld	(xpmp_channel\1.freqOffs+1),a
	ret
	xpmp_\1_cmd_F0_disable_VIBMAC:
	ld	(xpmp_channel\1.mpMac),a
	ld	(xpmp_channel\1.freqOffs),a
	ld	(xpmp_channel\1.freqOffs+1),a
	ret
	.ENDIF
	.ENDIF
	
	; Initialize sweep macro
	xpmp_\1_cmd_F0_check_SWPMAC:
	.IFNDEF XPMP_EPMAC_NOT_USED
	.IFDEF XPMP_CHN\1_USES_EP
	cp	CMD_SWPMAC
	jr	nz,xpmp_\1_cmd_F0_check_JMP
	ld	de,(xpmp_channel\1.dataPos)
	inc	de
	ld	(xpmp_channel\1.dataPos),de	
	inc	hl
	ld	a,(hl)
	ld	(xpmp_channel\1.epMac),a
	cp	EFFECT_DISABLED
	jr	z,xpmp_\1_cmd_F0_disable_SWPMAC	
	xpmp_\1_reset_ep_mac:
	dec	a
	add	a,a
	ld	hl,xpmp_EP_mac_tbl
	ld	d,0
	ld	e,a
	add	hl,de
	ld	a,(hl)	
	ld	(xpmp_channel\1.epMacPtr),a
	inc	hl
	ld	a,(hl)
	ld	(xpmp_channel\1.epMacPtr+1),a
	ld	hl,(xpmp_channel\1.epMacPtr)
	ld	a,1
	ld	(xpmp_channel\1.epMacPos),a
	dec	a
	ld	(xpmp_channel\1.freqOffs+1),a
	ld	a,(hl)
	ld	(xpmp_channel\1.freqOffs),a
	bit	7,a
	ret	z
	ld	a,$FF
	ld	(xpmp_channel\1.freqOffs+1),a
	ret
	xpmp_\1_cmd_F0_disable_SWPMAC:
	ld	(xpmp_channel\1.epMac),a
	ld	(xpmp_channel\1.freqOffs),a
	ld	(xpmp_channel\1.freqOffs+1),a
	ret
	.ENDIF
	.ENDIF
	.ENDIF
	
	; Jump
	xpmp_\1_cmd_F0_check_JMP:
	cp	CMD_JMP
	jr	nz,xpmp_\1_cmd_F0_check_LOPCNT
	inc	hl
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	dec	de				; dataPos will be increased after the return, so we decrease it here
	ld	(xpmp_channel\1.dataPos),de
	ret

	; Set loop count
	xpmp_\1_cmd_F0_check_LOPCNT:
	cp	CMD_LOPCNT
	jr	nz,xpmp_\1_cmd_F0_check_DJNZ
	ld	de,(xpmp_channel\1.dataPos)
	inc	de
	ld	(xpmp_channel\1.dataPos),de	
	inc	hl
	ld	a,(hl)
	ld	hl,(xpmp_channel\1.loopPtr)
	inc	hl
	ld	(hl),a
	ld	(xpmp_channel\1.loopPtr),hl
	ret

	; Decrease and jump if not zero
	xpmp_\1_cmd_F0_check_DJNZ:
	cp	CMD_DJNZ
	jr	nz,xpmp_\1_cmd_F0_check_APMAC2
	ld	hl,(xpmp_channel\1.loopPtr)
	dec	(hl)
	jr	z,xpmp_\1_cmd_F0_DJNZ_Z		; Check if the counter has reached zero
	ld	hl,(xpmp_tempw)
	inc	hl
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	dec	de				; dataPos will be increased after the return, so we decrease it here
	ld	(xpmp_channel\1.dataPos),de
	ret
	xpmp_\1_cmd_F0_DJNZ_Z:
	dec	hl
	ld	(xpmp_channel\1.loopPtr),hl
	ld	de,(xpmp_channel\1.dataPos)
	inc	de
	inc	de
	ld	(xpmp_channel\1.dataPos),de	
	ret
	
	; Initialize non-cumulative arpeggio macro
	xpmp_\1_cmd_F0_check_APMAC2:
	.IFNDEF XPMP_EN2MAC_NOT_USED
	.IFDEF XPMP_CHN\1_USES_EN2
	cp	CMD_APMAC2
	jr	nz,xpmp_\1_cmd_F0_check_ARPMAC
	inc	hl
	ld	de,(xpmp_channel\1.dataPos)
	inc	de
	ld	a,(hl)
	ld	(xpmp_channel\1.en2Mac),a
	ld	(xpmp_channel\1.dataPos),de
	xpmp_\1_reset_en2_mac:
	dec	a
	add	a,a
	ld	hl,xpmp_EN_mac_tbl
	ld	d,0
	ld	e,a
	add	hl,de
	ld	a,(hl)	
	ld	(xpmp_channel\1.en2MacPtr),a
	inc	hl
	ld	a,(hl)
	ld	(xpmp_channel\1.en2MacPtr+1),a
	ld	hl,(xpmp_channel\1.en2MacPtr)
	ld	a,(hl)
	ld	(xpmp_channel\1.noteOffs),a
	ld	a,1
	ld	(xpmp_channel\1.en2MacPos),a
	dec	a
	ld	(xpmp_channel\1.enMac),a
	ret
	.ENDIF
	.ENDIF
	
	; Initialize non-cumulative arpeggio macro
	xpmp_\1_cmd_F0_check_ARPMAC:
	.IFNDEF XPMP_ENMAC_NOT_USED
	.IFDEF XPMP_CHN\1_USES_EN
	cp	CMD_ARPMAC
	jr	nz,xpmp_\1_cmd_F0_check_PANMAC
	inc	hl
	ld	de,(xpmp_channel\1.dataPos)
	inc	de
	ld	a,(hl)
	ld	(xpmp_channel\1.enMac),a
	ld	(xpmp_channel\1.dataPos),de
	xpmp_\1_reset_en_mac:
	dec	a
	add	a,a
	ld	hl,xpmp_EN_mac_tbl
	ld	d,0
	ld	e,a
	add	hl,de
	ld	a,(hl)	
	ld	(xpmp_channel\1.enMacPtr),a
	inc	hl
	ld	a,(hl)
	ld	(xpmp_channel\1.enMacPtr+1),a
	ld	hl,(xpmp_channel\1.enMacPtr)
	ld	a,(hl)
	ld	(xpmp_channel\1.noteOffs),a
	ld	a,1
	ld	(xpmp_channel\1.enMacPos),a
	dec	a
	ld	(xpmp_channel\1.en2Mac),a
	ret
	.ENDIF
	.ENDIF
	
	xpmp_\1_cmd_F0_check_PANMAC:
	cp	CMD_PANMAC
	jr	nz,xpmp_\1_cmd_F0_check_END
	inc	hl
	ld	de,(xpmp_channel\1.dataPos)
	inc	de
	ld	(xpmp_channel\1.dataPos),de
	ld	a,(hl)
	ld	(xpmp_channel\1.csMac),a
	cp	EFFECT_DISABLED
	jr	z,xpmp_\1_cs_off
	xpmp_\1_reset_cs_mac:
	dec	a
	add	a,a
	ld	hl,xpmp_CS_mac_tbl
	ld	d,0
	ld	e,a
	add	hl,de
	ld	a,(hl)	
	ld	(xpmp_channel\1.csMacPtr),a
	inc	hl
	ld	a,(hl)
	ld	(xpmp_channel\1.csMacPtr+1),a
	ld	hl,(xpmp_channel\1.csMacPtr)
	ld	a,1
	ld	(xpmp_channel\1.csMacPos),a
	ld	a,(hl)
	xpmp_\1_write_pan:
	bit	7,a
	jr	z,xpmp_\1_reset_cs_pos
	ld	a,(xpmp_pan)
	res	\1,a
	set	4+\1,a
	ld	(xpmp_pan),a
	;.IFDEF	XPMP_GAME_GEAR
	out	($06),a
	;.ENDIF
	ret
	xpmp_\1_reset_cs_pos:
	cp	0
	jr	nz,xpmp_\1_reset_cs_right
	xpmp_\1_cs_off:
	ld	a,(xpmp_pan)
	or	$11<<\1
	ld	(xpmp_pan),a
	;.IFDEF	XPMP_GAME_GEAR
	out	($06),a
	;.ENDIF
	ret
	xpmp_\1_reset_cs_right:
	ld	a,(xpmp_pan)
	res	4+\1,a
	set	\1,a
	ld	(xpmp_pan),a
	;.IFDEF	XPMP_GAME_GEAR
	out	($06),a
	;.ENDIF
	ret
	
	xpmp_\1_cmd_F0_check_END:
	cp	CMD_END
	jr	nz,xpmp_\1_cmd_F0_not_found
	ld	a,CMD_END
	ld	(xpmp_channel\1.note),a		; Playback of this channel should end
	ld	a,2
	ld	(xpmp_freqChange),a		; The command-reading loop should exit	
	ret

	xpmp_\1_cmd_F0_not_found:
	ld	de,(xpmp_channel\1.dataPos)
	inc	de
	ld	(xpmp_channel\1.dataPos),de	
	
	ret
.endm	


xpmp_call_hl:
	jp (hl)
	


.MACRO XPMP_UPDATE_FUNC 

xpmp_\1_update:
	ld	a,0
	ld	(xpmp_freqChange),a
	ld	(xpmp_volChange),a
	
	ld	a,(xpmp_channel\1.note)
	cp	CMD_END
	ret	z				; Playback has ended for this channel - all processing should be skipped
	
	ld 	hl,(xpmp_channel\1.delay+1)	; Decrement the whole part of the delay and check if it has reached zero
	dec	hl
	ld	a,h
	or	l
	jp 	nz,xpmp_\1_update_effects	
	
	; Loop here until a note/rest or END command is read (signaled by xpmp_freqChange == 2)
	xpmp_\1_update_read_cmd:
	ld	hl,(xpmp_channel\1.dataPtr)
	ld 	de,(xpmp_channel\1.dataPos)
	add 	hl,de
	ld 	c,(hl)
	ld	(xpmp_tempw),hl			; Store HL for later use
	ld	a,c
	srl	a
	srl	a
	srl	a
	res	0,a				; A = (C>>3)&~1 = (C>>4)<<1
	ld	l,a
	ld	h,0
	ld	de,xpmp_\1_jump_tbl	
	add	hl,de
	ld	e,(hl)				; HL = jump_tbl + (command >> 4)
	inc	hl
	ld	d,(hl)
	ex	de,hl
	call	xpmp_call_hl

	ld	hl,(xpmp_channel\1.dataPos)
	inc	hl
	ld	(xpmp_channel\1.dataPos),hl

	ld	a,(xpmp_freqChange)
	cp	2
	jr	z,xpmp_update_\1_freq_change
	jp 	xpmp_\1_update_read_cmd
	
	xpmp_update_\1_freq_change:	
	ld	a,(xpmp_channel\1.note)
	cp	CMD_REST
	jp	z,xpmp_\1_rest
	cp	CMD_END
	jp	z,xpmp_\1_rest
	ld	b,a
	ld	a,(xpmp_channel\1.noteOffs)
	add	a,b
	.IF \1 < 3
	ld	b,a
	ld	a,(xpmp_channel\1.octave)
	add	a,b
	ld	hl,xpmp_freq_tbl
	ld	d,0
	add	a,a
	ld	e,a
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	ex	de,hl
	ld	de,(xpmp_channel\1.freqOffs)
	and	a
	sbc	hl,de
	ld	de,(xpmp_channel\1.detune)
	and	a
	sbc	hl,de
	JL_IMM16 $03EF,xpmp_updqte_\1_lb_ok
	ld	hl,(xpmp_freq_tbl+18)
	jp	xpmp_update_\1_freq_ok
	xpmp_updqte_\1_lb_ok:
	JGE_IMM16 $001C,xpmp_update_\1_freq_ok
	ld	hl,$001C
	xpmp_update_\1_freq_ok:
	ld	a,l
	and	$0F
	or	\1<<5|$80
	out	(XPMP_SN_PORT),a
	ld	a,h
	sla	l		
	rla			
	sla	l
	rla	
	sla	l
	rla	
	sla	l
	rla	
	out	(XPMP_SN_PORT),a
	.ELSE
	and	3
	ld	b,a
	ld	a,(xpmp_channel3.duty)
	or	b
	or	$E0
	out	(XPMP_SN_PORT),a
	xor	$E0
	out	(XPMP_SN_PORT),a
	.ENDIF
	ld	a,(xpmp_lastNote)
	cp	CMD_REST
	jr	nz,xpmp_\1_update_set_vol2
	jp	xpmp_\1_update_set_vol3

	xpmp_\1_update_set_vol:
	ld	a,(xpmp_channel\1.note)
	cp	CMD_REST
	jr	z,xpmp_\1_rest
	xpmp_\1_update_set_vol2:
	; Update the volume if it has changed
	ld	a,(xpmp_volChange)
	cp	0
	ret	z
	xpmp_\1_update_set_vol3:
	ld	a,(xpmp_channel\1.volume)
	;ld	b,a
	;ld	a,(xpmp_channel\1.volOffs)
	;add	a,b
	;ld	b,a
	;and	$F0
	;jr	z,xpmp_\1_vol_ok
	;bit	7,a
	;jr	z,xpmp_\1_vol_too_large
	;ld	b,$00
	;jp	xpmp_\1_vol_ok
	;xpmp_\1_vol_too_large:
	;ld	b,$0F
	;xpmp_\1_vol_ok:
	;ld	a,b
	xor	$9F|(\1<<5)
	out	(XPMP_SN_PORT),a
	res	7,a
	out	(XPMP_SN_PORT),a
	xpmp_update_\1_no_vol_change:
	ret
	
	; Mute the channel
	xpmp_\1_rest:
	ld	a,$9F|(\1<<5)
	out	(XPMP_SN_PORT),a
	res	7,a
	out	(XPMP_SN_PORT),a
	ret

	xpmp_\1_update_effects:
	ld 	(xpmp_channel\1.delay+1),hl

	.IFNDEF XPMP_VMAC_NOT_USED
	; Volume macro
	ld 	a,(xpmp_channel\1.vMac)
	cp 	EFFECT_DISABLED
	jr 	z,xpmp_update_\1_v_done 
	xpmp_update_\1_v:
	ld 	hl,(xpmp_channel\1.vMacPtr)
	ld	a,1
	ld	(xpmp_volChange),a
	ld 	d,0
	ld 	a,(xpmp_channel\1.vMacPos)
	ld 	e,a
	add 	hl,de				; Add macro position to pointer
	ld 	a,(hl)
	cp 	128				; If we read a value of 128 we should loop
	jr 	z,xpmp_update_\1_v_loop
	ld	(xpmp_channel\1.volume),a 	; Set a new volume
	inc	de				; Increase the position
	ld	a,e
	ld	(xpmp_channel\1.vMacPos),a
	jp	xpmp_update_\1_v_done
	xpmp_update_\1_v_loop:
	ld	a,(xpmp_channel\1.vMac)		; Which volume macro are we using?
	dec	a
	ld	e,a
	sla	e				; Each pointer is two bytes
	ld	bc,xpmp_v_mac_loop_tbl
	ld	hl,xpmp_channel\1.vMacPtr
	ex	de,hl
	add	hl,bc 				; HL = xpmp_vMac_loop_tbl + (vMac - 1)*2
	ld	a,(hl)				; Read low byte of pointer
	ld	(de),a				; Store in xpmp_\1_vMac_ptr
	inc 	de	
	inc	hl
	ld	a,(hl)				; Read high byte of pointer
	ld	(de),a
	ld	a,1
	ld	(xpmp_channel\1.vMacPos),a
	ld	hl,(xpmp_channel\1.vMacPtr)
	ld	a,(hl)
	ld	(xpmp_channel\1.volume),a
	xpmp_update_\1_v_done:
	.ENDIF
	
	.IFNDEF XPMP_ENMAC_NOT_USED
	.IFDEF XPMP_CHN\1_USES_EN
	; Cumulative arpeggio
	ld 	a,(xpmp_channel\1.enMac)
	cp	EFFECT_DISABLED
	jr 	z,xpmp_update_\1_EN_done
	xpmp_update_\1_EN:
	ld	a,1
	ld	(xpmp_freqChange),a		; Frequency has changed, but we haven't read a new note/rest yet
	ld	hl,(xpmp_channel\1.enMacPtr)
	ld 	d,0
	ld 	a,(xpmp_channel\1.enMacPos)
	ld 	e,a
	add 	hl,de				; Add macro position to pointer
	ld 	a,(hl)
	cp 	128				; If we read a value of 128 we should loop
	jr 	z,xpmp_update_\1_EN_loop
	ld	b,a
	ld	a,(xpmp_channel\1.noteOffs)
	add	a,b
	ld	(xpmp_channel\1.noteOffs),a	; Number of semitones to offset the current note by
	inc	de				; Increase the position
	ld	a,e				
	ld	(xpmp_channel\1.enMacPos),a
	jp	xpmp_update_\1_EN_done		
	xpmp_update_\1_EN_loop:
	ld	a,(xpmp_channel\1.enMac)	; Which arpeggio macro are we using?
	dec	a
	add	a,a				; Each pointer is two bytes
	ld	e,a
	ld	hl,xpmp_channel\1.enMacPtr
	ld	bc,xpmp_EN_mac_loop_tbl
	ex	de,hl
	add	hl,bc				; HL = xpmp_EN_mac_loop_tbl + (enMac - 1)*2
	ld	a,(hl)				; Read low byte of pointer
	ld	(de),a
	inc 	de
	inc	hl
	ld	a,(hl)				; Read high byte of pointer
	ld	(de),a
	ld	a,1
	ld	(xpmp_channel\1.enMacPos),a	; Reset position
	ld	hl,(xpmp_channel\1.enMacPtr)
	ld	b,(hl)
	ld	a,(xpmp_channel\1.noteOffs)
	add	a,b
	ld	(xpmp_channel\1.noteOffs),a	; Reset note offset
	xpmp_update_\1_EN_done:
	.ENDIF
	.ENDIF
	
	.IFNDEF XPMP_EN2MAC_NOT_USED
	.IFDEF XPMP_CHN\1_USES_EN2
	; Non-cumulative arpeggio
	ld 	a,(xpmp_channel\1.en2Mac)
	cp	EFFECT_DISABLED
	jr 	z,xpmp_update_\1_EN2_done
	xpmp_update_\1_EN2:
	ld	a,1
	ld	(xpmp_freqChange),a		; Frequency has changed, but we haven't read a new note/rest yet
	ld	hl,(xpmp_channel\1.en2MacPtr)
	ld 	d,0
	ld 	a,(xpmp_channel\1.en2MacPos)
	ld 	e,a
	add 	hl,de				; Add macro position to pointer
	ld 	a,(hl)
	cp 	128				; If we read a value of 128 we should loop
	jr 	z,xpmp_update_\1_EN2_loop
	ld	(xpmp_channel\1.noteOffs),a	; Number of semitones to offset the current note by
	inc	de				; Increase the position
	ld	a,e				
	ld	(xpmp_channel\1.en2MacPos),a
	jp	xpmp_update_\1_EN2_done		
	xpmp_update_\1_EN2_loop:
	ld	a,(xpmp_channel\1.en2Mac)	; Which arpeggio macro are we using?
	dec	a
	add	a,a				; Each pointer is two bytes
	ld	e,a
	ld	hl,xpmp_channel\1.en2MacPtr
	ld	bc,xpmp_EN_mac_loop_tbl
	ex	de,hl
	add	hl,bc				; HL = xpmp_EN_mac_loop_tbl + (en2Mac - 1)*2
	ld	a,(hl)				; Read low byte of pointer
	ld	(de),a
	inc 	de
	inc	hl
	ld	a,(hl)				; Read high byte of pointer
	ld	(de),a
	ld	a,1
	ld	(xpmp_channel\1.en2MacPos),a	; Reset position
	ld	hl,(xpmp_channel\1.en2MacPtr)
	ld	a,(hl)
	ld	(xpmp_channel\1.noteOffs),a	; Reset note offset
	xpmp_update_\1_EN2_done:
	.ENDIF
	.ENDIF
	
	.IF \1 < 3
	.IFNDEF XPMP_EPMAC_NOT_USED
	.IFDEF XPMP_CHN\1_USES_EP
	; Sweep macro
	ld 	a,(xpmp_channel\1.epMac)
	cp	EFFECT_DISABLED
	jr 	z,xpmp_update_\1_EP_done
	xpmp_update_\1_EP:
	ld	a,1
	ld	(xpmp_freqChange),a		; Frequency has changed, but we haven't read a new note/rest yet
	ld	hl,(xpmp_channel\1.epMacPtr)
	ld 	d,0
	ld 	a,(xpmp_channel\1.epMacPos)
	ld 	e,a
	add 	hl,de				; Add macro position to pointer
	ld 	a,(hl)
	cp 	128				; If we read a value of 128 we should loop
	jr 	z,xpmp_update_\1_EP_loop
	ld	b,a
	inc	de				; Increase the position
	ld	a,e				
	ld	(xpmp_channel\1.epMacPos),a
	ld	e,b
	ld	d,0
	bit	7,b
	jr	z,xpmp_update_\1_pos_freq
	ld	d,$FF
	xpmp_update_\1_pos_freq:
	ld	hl,(xpmp_channel\1.freqOffs)
	add	hl,de
	ld	(xpmp_channel\1.freqOffs),hl
	jp	xpmp_update_\1_EP_done		
	xpmp_update_\1_EP_loop:
	ld	a,(xpmp_channel\1.epMac)	; Which sweep macro are we using?
	dec	a
	add	a,a				; Each pointer is two bytes
	ld	e,a
	ld	hl,xpmp_channel\1.epMacPtr
	ld	bc,xpmp_EP_mac_loop_tbl
	ex	de,hl
	add	hl,bc				; HL = xpmp_EP_mac_loop_tbl + (epMac - 1)*2
	ld	a,(hl)				; Read low byte of pointer
	ld	(de),a
	inc 	de
	inc	hl
	ld	a,(hl)				; Read high byte of pointer
	ld	(de),a
	ld	a,1
	ld	(xpmp_channel\1.epMacPos),a	; Reset position
	ld	hl,(xpmp_channel\1.epMacPtr)
	ld	e,(hl)
	ld	d,0
	bit	7,e
	jr	z,xpmp_update_\1_pos_freq_2
	ld	d,$FF
	xpmp_update_\1_pos_freq_2:
	ld	hl,(xpmp_channel\1.freqOffs)
	add	hl,de
	ld	(xpmp_channel\1.freqOffs),hl
	xpmp_update_\1_EP_done:
	.ENDIF
	.ENDIF
	
	.IFNDEF XPMP_MPMAC_NOT_USED
	.IFDEF XPMP_CHN\1_USES_MP
	; Vibrato
	ld 	a,(xpmp_channel\1.mpMac)
	cp	EFFECT_DISABLED
	jr 	z,xpmp_update_\1_MP_done
	ld	a,(xpmp_channel\1.mpMacDelay)
	dec	a
	jr 	nz,xpmp_update_\1_MP_done2
	xpmp_update_\1_MP:
	ld	a,1
	ld	(xpmp_freqChange),a		; Volume has changed
	ld	hl,(xpmp_channel\1.mpMacPtr)
	ld	de,(xpmp_channel\1.freqOffsLatch) ; Load the volume offset from the latch, then negate the latch
	ld	(xpmp_channel\1.freqOffs),de
	and	a				; Clear carry
	ld 	a,(hl)				; Reload the vibrato delay
	ld	hl,0
	sbc	hl,de
	ld	(xpmp_channel\1.freqOffsLatch),hl
	xpmp_update_\1_MP_done2:
	ld	(xpmp_channel\1.mpMacDelay),a
	xpmp_update_\1_MP_done:
	.ENDIF
	.ENDIF
	.ENDIF

	;.IFDEF XPMP_GAME_GEAR
	; Channel separation (pan) macro
	ld 	a,(xpmp_channel\1.csMac)
	cp	EFFECT_DISABLED
	jr 	z,xpmp_update_\1_CS_done
	xpmp_update_\1_CS:
	ld	hl,(xpmp_channel\1.csMacPtr)
	ld 	d,0
	ld 	a,(xpmp_channel\1.csMacPos)
	ld 	e,a
	add 	hl,de				; Add macro position to pointer
	ld 	a,(hl)
	cp 	128				; If we read a value of 128 we should loop
	jr 	z,xpmp_update_\1_CS_loop
	ld	b,a

	inc	de				; Increase the position
	ld	a,e				
	ld	(xpmp_channel\1.csMacPos),a
	jp	xpmp_update_\1_CS_do_write		
	xpmp_update_\1_CS_loop:
	ld	a,(xpmp_channel\1.csMac)	; Which pan macro are we using?
	dec	a
	add	a,a				; Each pointer is two bytes
	ld	e,a
	ld	hl,xpmp_channel\1.csMacPtr
	ld	bc,xpmp_CS_mac_loop_tbl
	ex	de,hl
	add	hl,bc				; HL = xpmp_CS_mac_loop_tbl + (csMac - 1)*2
	ld	a,(hl)				; Read low byte of pointer
	ld	(de),a
	inc 	de
	inc	hl
	ld	a,(hl)				; Read high byte of pointer
	ld	(de),a
	ld	a,1
	ld	(xpmp_channel\1.csMacPos),a	; Reset position
	ld	hl,(xpmp_channel\1.csMacPtr)
	ld	b,(hl)
	xpmp_update_\1_CS_do_write:
	ld	a,b
	call	xpmp_\1_write_pan
	xpmp_update_\1_CS_done:
	;.ENDIF
	
	ld	a,(xpmp_freqChange)
	cp	0
	jp	nz,xpmp_update_\1_freq_change
	jp	xpmp_\1_update_set_vol
	
 .ENDM


;######################################################################################################################


.IFDEF XPMP_USES_AY

; Note / rest
xpmp_ay_cmd_00:
xpmp_ay_cmd_60:
	ld	hl,(xpmp_tempw)
xpmp_ay_cmd_00_2:
	ld	a,(ix+7)
	ld	(xpmp_lastNote),a
	ld	a,c
	and	$0F
	ld	(ix+7),a
	ld	a,c
	and	$F0
	cp	CMD_NOTE2
	jr	z,xpmp_ay_cmd_00_std_delay	
	ld	e,(ix+2)
	ld	d,(ix+3)
	inc	de
	inc	de
	ld	(ix+2),e
	ld	(ix+3),d
	inc	hl
	ld	a,(hl)
	bit	7,a
	jr	z,xpmp_ay_cmd_00_short_note
		inc	de
		ld	(ix+2),e
		ld	(ix+3),d
		inc	hl
		res	7,a
		ld	d,a
		srl	d
		rrc	a
		and	$80
		ld	e,(hl)
		or	e
		ld	e,a
		inc	hl
		ld	a,(ix+4)	
		add	a,(hl)
		ld	(ix+4),a		; Fractional part
		ld	hl,0 
		adc	hl,de
		ld	(ix+5),l		; Whole part
		ld	(ix+6),h
		jp 	xpmp_ay_cmd_00_got_delay
	xpmp_ay_cmd_00_short_note:
	ld	d,0
	ld	e,a
	inc	hl
	ld	a,(ix+4)	
	add	a,(hl)
	ld	(ix+4),a			; Fractional part
	ld	hl,0 
	adc	hl,de
	ret	z
	ld	(ix+5),l			; Whole part
	ld	(ix+6),h
	jp 	xpmp_ay_cmd_00_got_delay
	xpmp_ay_cmd_00_std_delay:		; Use delay set by last CMD_LEN
	ld	a,(ix+52)
	ld	b,a
	ld	a,(ix+4)
	add	a,b
	ld	(ix+4),a
	ld 	l,(ix+53)
	ld	h,(ix+54)
	ld	de,0
	adc	hl,de
	ret	z
	ld	(ix+5),l
	ld	(ix+6),h
	xpmp_ay_cmd_00_got_delay:
	ld	a,2
	ld	(xpmp_freqChange),a
	ld	a,(ix+7)
	cp	CMD_REST	
	ret	z				; If this was a rest command we can return now
	.IFNDEF XPMP_VMAC_NOT_USED
	ld	a,(ix+22)
	cp	EFFECT_DISABLED
	call	nz,xpmp_ay_reset_v_mac	; Reset effects as needed..
	.ENDIF
	.IFNDEF XPMP_ENMAC_NOT_USED
	ld	a,(ix+26)
	cp	EFFECT_DISABLED
	call	nz,xpmp_ay_reset_en_mac
	.ENDIF
	.IFNDEF XPMP_EN2MAC_NOT_USED
	ld	a,(ix+30)
	cp	EFFECT_DISABLED
	call	nz,xpmp_ay_reset_en2_mac
	.ENDIF
	.IFNDEF XPMP_MPMAC_NOT_USED
	ld	a,(ix+38)
	cp	EFFECT_DISABLED
	call	nz,xpmp_ay_reset_mp_mac
	.ENDIF
	.IFNDEF XPMP_EPMAC_NOT_USED
	ld	a,(ix+34)
	cp	EFFECT_DISABLED
	call	nz,xpmp_ay_reset_ep_mac
	.ENDIF
	ret
	
; Set octave
xpmp_ay_cmd_10:
	ld	a,c 
	and	$0F
	;sub	1				; Minimum octave is 1
	ld	b,a
	add	a,a
	add	a,a
	sla	b
	sla	b
	sla	b
	add	a,b				; A = (C & $0F) * 12
	ld	(ix+9),a
	ret
	
xpmp_ay_cmd_20:
	ld	a,c
	and	1
	ld	b,a
	ld	a,c
	and	2
	sla	a
	sla	a
	or	b				; Tone/noise enable flags
	ld	b,a
	ld	d,$84
	rrc	b
	ld	a,(xpmp_chnum)
	inc	a
	xpmp_ay_cmd_20_shift:			; Shift left by the channel number
	rlc	b
	rlc	d
	dec	a
	jr	nz,xpmp_ay_cmd_20_shift
	ld	a,d
	ld	d,a
	ld	a,(xpmp_ayen)
	or	d				; Clear the tone/noise enable flags for this channel
	ld	d,a
	ld	a,b
	xor	$FF
	and	d
	ld	(xpmp_ayen),a
	ld	a,7
	out	(XPMP_AY_ADDR),a
	ld	a,(xpmp_ayen)
	out	(XPMP_AY_DATA),a
	ld	a,c
	srl	a
	and	2
	ld	b,a
	srl	b
	or	b
	sla	a
	sla	a
	sla	a
	sla	a
	ld	(ix+15),a			; envelope on/off
	ret

; Set volume (short)
xpmp_ay_cmd_30:
	ld	a,c
	and	$0F
	ld	(ix+13),a
	ld	a,1
	ld	(xpmp_volChange),a		; Volume has changed
	ld	a,EFFECT_DISABLED
	ld	(ix+22),a			; Volume set overrides volume macros
	ret

; Octave up + note	
xpmp_ay_cmd_40:
	ld	hl,(xpmp_tempw)
	ld	a,(ix+9)
	add	a,12
	ld	(ix+9),a
	jp	xpmp_ay_cmd_00_2

; Octave down + note
xpmp_ay_cmd_50:
	ld	hl,(xpmp_tempw)
	ld	a,(ix+9)
	sub	12
	ld	(ix+9),a
	jp	xpmp_ay_cmd_00_2

xpmp_ay_cmd_70:
xpmp_ay_cmd_80:
	ret

; Turn off arpeggio macro
xpmp_ay_cmd_90:
	ld	a,c
	cp	CMD_JSR
	jr	z,xpmp_ay_cmd_90_jsr
	cp	CMD_RTS
	jr	z,xpmp_ay_cmd_90_rts
	cp	CMD_LEN
	jr	z,xpmp_ay_cmd_90_len
	cp	CMD_HWES
	jp	z,xpmp_ay_cmd_90_hwes
	cp	CMD_HWNS
	jp	z,xpmp_ay_cmd_90_hwns
	
	ld	hl,(xpmp_tempw)
	ld	a,0
	ld	(ix+26),a
	ld	(ix+30),a
	ld	(ix+8),a
	ret

	; Jump to pattern
	xpmp_ay_cmd_90_jsr:
	ld	e,(ix+2)
	ld	d,(ix+3)
	inc	de
	ld	(ix+50),e
	ld	(ix+51),d
	ld	a,(ix+0)
	ld	(ix+48),a
	ld	a,(ix+1)
	ld	(ix+49),a
	ld	hl,(xpmp_tempw)
	inc	hl
	ld	a,(hl)
	ld	de,xpmp_pattern_tbl
	ld	h,0
	add	a,a
	ld	l,a
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	ld	(ix+0),e
	ld	(ix+1),d
	ld	a,$FF
	ld	(ix+2),a
	ld	(ix+3),a
	ret
	
	; Return from pattern
	xpmp_ay_cmd_90_rts:
	ld	a,(ix+48)
	ld	(ix+0),a
	ld	a,(ix+49)
	ld	(ix+1),a
	ld	a,(ix+50)
	ld	(ix+2),a
	ld	a,(ix+51)
	ld	(ix+3),a
	ret

	xpmp_ay_cmd_90_len:
	ld	hl,(xpmp_tempw)
	ld	e,(ix+2)
	ld	d,(ix+3)
	inc	de
	inc	de
	ld	(ix+2),e
	ld	(ix+3),d
	inc	hl
	ld	a,(hl)
	bit	7,a
	jr	z,xpmp_ay_cmd_90_short_delay
		inc	de
		ld	(ix+2),e
		ld	(ix+3),d
		inc	hl
		res	7,a
		ld	d,a
		srl	d
		rrc	a
		and	$80
		ld	e,(hl)
		or	e
		ld	e,a
		inc	hl
		ld	a,(hl)
		ld	(ix+52),a	; Fractional part
		ld	(ix+53),e	; Whole part
		ld	(ix+54),d
		ret
	xpmp_ay_cmd_90_short_delay:
	ld	d,0
	ld	e,a
	inc	hl
	ld	a,(hl)
	ld	(ix+52),a	; Fractional part
	ld	(ix+53),e	; Whole part
	ld	(ix+54),d	; ...
	ret

	; Envelope speed
	xpmp_ay_cmd_90_hwes:
	ld	e,(ix+2)
	ld	d,(ix+3)
	inc	de
	inc	de
	ld	(ix+2),e
	ld	(ix+3),d
	inc	hl
	ld	a,11
	out	(XPMP_AY_ADDR),a
	ld	a,(hl)
	out	(XPMP_AY_DATA),a
	inc	hl
	ld	a,12
	out	(XPMP_AY_ADDR),a
	ld	a,(hl)
	out	(XPMP_AY_DATA),a
	ret

	; Noise speed (inverted period)
	xpmp_ay_cmd_90_hwns:
	ld	e,(ix+2)
	ld	d,(ix+3)
	inc	de
	ld	(ix+2),e
	ld	(ix+3),d	
	inc	hl
	ld	a,6
	out	(XPMP_AY_ADDR),a
	ld	a,(hl)
	out	(XPMP_AY_DATA),a
	ret
	
xpmp_ay_cmd_A0:
xpmp_ay_cmd_B0:
xpmp_ay_cmd_C0:
xpmp_ay_cmd_D0:
	ret
	

; Callback
xpmp_ay_cmd_E0:
	ld	hl,(xpmp_tempw)
	inc	(ix+2)
	jr	nz,+
	inc	(ix+3)
	+:
	ld	a,c
	cp	CMD_CBOFF
	jr	z,xpmp_ay_cmd_E0_cboff
	cp	CMD_CBONCE
	jr	z,xpmp_ay_cmd_E0_cbonce
	cp	CMD_CBEVNT
	jr	z,xpmp_ay_cmd_E0_cbevnt
	cp	CMD_DETUNE
	jr	z,xpmp_ay_cmd_E0_detune
	cp	CMD_HWTE
	jr	z,xpmp_ay_cmd_E0_hwte
	ret
	
	xpmp_ay_cmd_E0_cboff:
	ret
	
	xpmp_ay_cmd_E0_cbonce:
	ret
	
	; Every note
	xpmp_ay_cmd_E0_cbevnt:
	ret

	xpmp_ay_cmd_E0_detune:
	inc	hl
	ld	e,(hl)
	ld	d,0
	bit	7,e
	jr	z,xpmp_ay_cmd_E0_detune_pos
	ld	d,$FF
	xpmp_ay_cmd_E0_detune_pos:
	ld	(ix+20),e
	ld	(ix+21),d
	ret

	; Envelope shape
	xpmp_ay_cmd_E0_hwte:
	ld	e,(ix+2)
	ld	d,(ix+3)
	inc	de
	ld	(ix+2),e
	ld	(ix+3),d	
	inc	hl
	ld	a,13
	out	(XPMP_AY_ADDR),a
	ld	a,(hl)
	ld	(ix+14),a
	out	(XPMP_AY_DATA),a
	ret
	
xpmp_ay_cmd_F0:
	ld	hl,(xpmp_tempw)
	inc	(ix+2)
	jr	nz,+
	inc	(ix+3)
	+:	
	; Initialize volume macro	
	ld	a,c

	.IFNDEF XPMP_VMAC_NOT_USED
	cp	CMD_VOLMAC
	jr	nz,xpmp_ay_cmd_F0_check_VIBMAC
	inc	hl
	ld	a,(hl)
	ld	(ix+22),a
	xpmp_ay_reset_v_mac:
	dec	a
	add	a,a
	ld	hl,xpmp_v_mac_tbl
	ld	d,0
	ld	e,a
	add	hl,de
	ld	a,(hl)	
	ld	(ix+23),a
	inc	hl
	ld	a,(hl)
	ld	(ix+24),a
	ld	l,(ix+23)
	ld	h,(ix+24)
	ld	a,(hl)
	ld	(ix+13),a
	ld	a,1
	ld	(xpmp_volChange),a	
	ld	a,1
	ld	(ix+25),a
	ret
	.ENDIF
	
	;.IF \1 < 3
	xpmp_ay_cmd_F0_check_VIBMAC:
	.IFNDEF XPMP_MPMAC_NOT_USED
	; Initialize vibrato macro
	cp	CMD_VIBMAC
	jr	nz,xpmp_ay_cmd_F0_check_SWPMAC
	inc	hl
	ld	a,(hl)
	cp	EFFECT_DISABLED
	jr	z,xpmp_ay_cmd_F0_disable_VIBMAC
	ld	(ix+38),a
	xpmp_ay_reset_mp_mac:
	dec	a
	add	a,a
	ld	hl,xpmp_MP_mac_tbl
	ld	d,0
	ld	e,a
	add	hl,de
	ld	a,(hl)
	ld	(ix+39),a
	inc	hl
	ld	a,(hl)
	ld	(ix+40),a
	ld	l,(ix+39)
	ld	h,(ix+40)
	ld	a,(hl)
	ld	(ix+41),a
	inc	hl
	ld	(ix+39),l
	ld	(ix+40),h
	inc	hl
	ld	a,(hl)
	ld	(ix+18),a
	ld	a,0
	ld	(ix+19),a
	ld	(ix+16),a
	ld	(ix+17),a
	ret
	xpmp_ay_cmd_F0_disable_VIBMAC:
	ld	(ix+38),a
	ld	(ix+16),a
	ld	(ix+17),a
	ret
	.ENDIF
	
	; Initialize sweep macro
	xpmp_ay_cmd_F0_check_SWPMAC:
	.IFNDEF XPMP_EPMAC_NOT_USED
	cp	CMD_SWPMAC
	jr	nz,xpmp_ay_cmd_F0_check_JMP
	inc	hl
	ld	a,(hl)
	ld	(ix+34),a
	cp	EFFECT_DISABLED
	jr	z,xpmp_ay_cmd_F0_disable_SWPMAC	
	xpmp_ay_reset_ep_mac:
	dec	a
	add	a,a
	ld	hl,xpmp_EP_mac_tbl
	ld	d,0
	ld	e,a
	add	hl,de
	ld	a,(hl)	
	ld	(ix+35),a
	inc	hl
	ld	a,(hl)
	ld	(ix+36),a
	ld	l,(ix+35)
	ld	h,(ix+36)
	ld	a,1
	ld	(ix+37),a
	dec	a
	ld	(ix+17),a
	ld	a,(hl)
	ld	(ix+16),a
	bit	7,a
	ret	z
	ld	a,$FF
	ld	(ix+17),a
	ret
	xpmp_ay_cmd_F0_disable_SWPMAC:
	ld	(ix+34),a
	ld	(ix+16),a
	ld	(ix+17),a
	ret
	.ENDIF
	
	; Jump
	xpmp_ay_cmd_F0_check_JMP:
	cp	CMD_JMP
	jr	nz,xpmp_ay_cmd_F0_check_LOPCNT
	inc	hl
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	dec	de				; dataPos will be increased after the return, so we decrease it here
	ld	(ix+2),e
	ld	(ix+3),d
	ret

	; Set loop count
	xpmp_ay_cmd_F0_check_LOPCNT:
	cp	CMD_LOPCNT
	jr	nz,xpmp_ay_cmd_F0_check_DJNZ
	inc	hl
	ld	a,(hl)
	ld	l,(ix+44)
	ld	h,(ix+45)
	inc	hl
	ld	(hl),a
	ld	(ix+44),l
	ld	(ix+45),h
	ret

	; Decrease and jump if not zero
	xpmp_ay_cmd_F0_check_DJNZ:
	cp	CMD_DJNZ
	jr	nz,xpmp_ay_cmd_F0_check_APMAC2
	ld	l,(ix+44)
	ld	h,(ix+45)
	dec	(hl)
	jr	z,xpmp_ay_cmd_F0_DJNZ_Z	; Check if the counter has reached zero
	ld	hl,(xpmp_tempw)
	inc	hl
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	dec	de				; dataPos will be increased after the return, so we decrease it here
	ld	(ix+2),e
	ld	(ix+3),d
	ret
	xpmp_ay_cmd_F0_DJNZ_Z:
	dec	hl
	ld	(ix+44),l
	ld	(ix+45),h
	inc	(ix+2)
	jr	nz,+
	inc	(ix+3)
	+:	
	ret
	
	; Initialize non-cumulative arpeggio macro
	xpmp_ay_cmd_F0_check_APMAC2:
	.IFNDEF XPMP_EN2MAC_NOT_USED
	cp	CMD_APMAC2
	jr	nz,xpmp_ay_cmd_F0_check_ARPMAC
	inc	hl
	ld	a,(hl)
	ld	(ix+30),a
	xpmp_ay_reset_en2_mac:
	dec	a
	add	a,a
	ld	hl,xpmp_EN_mac_tbl
	ld	d,0
	ld	e,a
	add	hl,de
	ld	a,(hl)	
	ld	(ix+31),a
	inc	hl
	ld	a,(hl)
	ld	(ix+32),a
	ld	l,(ix+31)
	ld	h,(ix+32)
	ld	a,(hl)
	ld	(ix+8),a
	ld	a,1
	ld	(ix+33),a
	dec	a
	ld	(ix+26),a
	ret
	.ENDIF
	
	; Initialize non-cumulative arpeggio macro
	xpmp_ay_cmd_F0_check_ARPMAC:
	.IFNDEF XPMP_ENMAC_NOT_USED
	cp	CMD_ARPMAC
	jr	nz,xpmp_ay_cmd_F0_check_PANMAC
	inc	hl
	ld	a,(hl)
	ld	(ix+26),a
	xpmp_ay_reset_en_mac:
	dec	a
	add	a,a
	ld	hl,xpmp_EN_mac_tbl
	ld	d,0
	ld	e,a
	add	hl,de
	ld	a,(hl)	
	ld	(ix+27),a
	inc	hl
	ld	a,(hl)
	ld	(ix+28),a
	ld	l,(ix+27)
	ld	h,(ix+28)
	ld	a,(hl)
	ld	(ix+8),a
	ld	a,1
	ld	(ix+29),a
	dec	a
	ld	(ix+30),a
	ret
	.ENDIF
	
	xpmp_ay_cmd_F0_check_PANMAC:
	cp	CMD_PANMAC
	jr	nz,xpmp_ay_cmd_F0_check_END
	inc	hl
	;ld	a,(hl)
	ld	a,0
	;ld	(xpmp_channel\1.csMac),a
	ret
	
	xpmp_ay_cmd_F0_check_END:
	cp	CMD_END
	jr	nz,xpmp_ay_cmd_F0_not_found
	ld	a,CMD_END
	ld	(ix+7),a			; Playback of this channel should end
	ld	a,2
	ld	(xpmp_freqChange),a		; The command-reading loop should exit	
	ret

	xpmp_ay_cmd_F0_not_found:
	ret
	
	
	
xpmp_update_ay:
	ld	(xpmp_chnum),a
	add	a,a
	ld	e,a
	ld	d,0
	ld	hl,xpmp_ay_channel_ptr_tbl
	add	hl,de
	ld	a,(hl)
	ld	(xpmp_tempw),a
	inc	hl
	ld	a,(hl)
	ld	(xpmp_tempw+1),a
	ld	ix,(xpmp_tempw)
	
	ld	a,0
	ld	(xpmp_freqChange),a
	ld	(xpmp_volChange),a
	
	ld	a,(ix+7)
	cp	CMD_END
	ret	z				; Playback has ended for this channel - all processing should be skipped
	
	ld 	l,(ix+5)			; Decrement the whole part of the delay and check if it has reached zero
	ld	h,(ix+6)
	dec	hl
	ld	a,h
	or	l
	jp 	nz,xpmp_update_ay_effects	
	
	; Loop here until a note/rest or END command is read (signaled by xpmp_freqChange == 2)
	xpmp_update_ay_read_cmd:
	ld	l,(ix+0)
	ld	h,(ix+1)
	ld	e,(ix+2)
	ld	d,(ix+3)
	add 	hl,de
	ld 	c,(hl)
	ld	(xpmp_tempw),hl			; Store HL for later use
	ld	a,c
	srl	a
	srl	a
	srl	a
	res	0,a				; A = (C>>3)&~1 = (C>>4)<<1
	ld	l,a
	ld	h,0
	ld	de,xpmp_ay_jump_tbl	
	add	hl,de
	ld	e,(hl)				; HL = jump_tbl + (command >> 4)
	inc	hl
	ld	d,(hl)
	ex	de,hl
	call	xpmp_call_hl

	inc	(ix+2)
	jr	nz,+
	inc	(ix+3)
	+:
	
	ld	a,(xpmp_freqChange)
	cp	2
	jr	z,xpmp_update_ay_freq_change
	jp 	xpmp_update_ay_read_cmd
	
	xpmp_update_ay_freq_change:
	ld	a,(ix+7)
	cp	CMD_REST
	jp	z,xpmp_update_ay_rest
	cp	CMD_END
	jp	z,xpmp_update_ay_rest
	ld	b,a
	ld	a,(ix+8)
	add	a,b
	ld	b,a
	ld	a,(ix+9)
	add	a,b
	ld	hl,ay_freq_tbl
	ld	d,0
	add	a,a
	ld	e,a
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	ex	de,hl
	ld	e,(ix+16)
	ld	d,(ix+17)
	and	a
	sbc	hl,de
	ld	e,(ix+20)
	ld	d,(ix+21)
	and	a
	sbc	hl,de
	JL_IMM16 $0FFF,xpmp_update_ay_lb_ok
	ld	hl,(ay_freq_tbl+18)
	jp	xpmp_update_ay_freq_ok
	xpmp_update_ay_lb_ok:
	JGE_IMM16 $001C,xpmp_update_ay_freq_ok
	ld	hl,$001C
	xpmp_update_ay_freq_ok:
	ex	de,hl
	ld	a,(xpmp_chnum)
	add	a,a
	out	(XPMP_AY_ADDR),a
	ld	b,a
	ld	a,e
	out	(XPMP_AY_DATA),a
	ld	a,b
	inc	a
	out	(XPMP_AY_ADDR),a
	ld	a,d
	out	(XPMP_AY_DATA),a
	
	; Restart envelope generator
	ld	a,13
	out	(XPMP_AY_ADDR),a
	ld	a,(ix+14)
	out	(XPMP_AY_DATA),a
	
	ld	a,(xpmp_lastNote)
	cp	CMD_REST
	jr	nz,xpmp_update_ay_set_vol2
	jp	xpmp_update_ay_set_vol3

	xpmp_update_ay_set_vol:
	ld	a,(ix+7)
	cp	CMD_REST
	jr	z,xpmp_update_ay_rest
	xpmp_update_ay_set_vol2:
	; Update the volume if it has changed
	ld	a,(xpmp_volChange)
	cp	0
	ret	z
	xpmp_update_ay_set_vol3:
	ld	a,(xpmp_chnum)
	add	a,8
	out	(XPMP_AY_ADDR),a
	ld	a,(ix+13)		; volume
	or	(ix+15)			; envelope on/off
	out	(XPMP_AY_DATA),a
	xpmp_update_ay_no_vol_change:
	ret
	
	; Mute the channel
	xpmp_update_ay_rest:
	ld	a,(xpmp_chnum)
	add	a,8
	out	(XPMP_AY_ADDR),a
	ld	a,(ix+15)		; envelope on/off
	out	(XPMP_AY_DATA),a
	ret
	
	xpmp_update_ay_effects:
	ld 	(ix+5),l
	ld	(ix+6),h

	.IFNDEF XPMP_VMAC_NOT_USED
	; Volume macro
	ld 	a,(ix+22)
	cp 	EFFECT_DISABLED
	jr 	z,xpmp_update_ay_v_done 
	xpmp_update_ay_v:
	ld 	l,(ix+23)
	ld	h,(ix+24)
	ld	a,1
	ld	(xpmp_volChange),a
	ld 	d,0
	ld 	a,(ix+25)
	ld 	e,a
	add 	hl,de				; Add macro position to pointer
	ld 	a,(hl)
	cp 	128				; If we read a value of 128 we should loop
	jr 	z,xpmp_update_ay_v_loop
	ld	(ix+13),a		 	; Set a new volume
	inc	de				; Increase the position
	ld	a,e
	ld	(ix+25),a
	jp	xpmp_update_ay_v_done
	xpmp_update_ay_v_loop:
	ld	a,(ix+22)			; Which volume macro are we using?
	dec	a
	ld	e,a
	sla	e				; Each pointer is two bytes
	ld	bc,xpmp_v_mac_loop_tbl
	ex	de,hl
	add	hl,bc 				; HL = xpmp_vMac_loop_tbl + (vMac - 1)*2
	ld	a,(hl)				; Read low byte of pointer
	ld	(ix+23),a			; Store in xpmp_\1_vMac_ptr
	inc	hl
	ld	a,(hl)				; Read high byte of pointer
	ld	(ix+24),a
	ld	a,1
	ld	(ix+25),a
	ld	l,(ix+23)
	ld	h,(ix+24)
	ld	a,(hl)
	ld	(ix+13),a
	xpmp_update_ay_v_done:
	.ENDIF
	
	.IFNDEF XPMP_ENMAC_NOT_USED
	; Cumulative arpeggio
	ld 	a,(ix+26)
	cp	EFFECT_DISABLED
	jr 	z,xpmp_update_ay_EN_done
	xpmp_update_ay_EN:
	ld	a,1
	ld	(xpmp_freqChange),a		; Frequency has changed, but we haven't read a new note/rest yet
	ld	l,(ix+27)
	ld	h,(ix+28)
	ld 	d,0
	ld 	e,(ix+29)
	add 	hl,de				; Add macro position to pointer
	ld 	a,(hl)
	cp 	128				; If we read a value of 128 we should loop
	jr 	z,xpmp_update_ay_EN_loop
	ld	b,a
	ld	a,(ix+8)
	add	a,b
	ld	(ix+8),a			; Number of semitones to offset the current note by
	inc	de				; Increase the position
	ld	a,e				
	ld	(ix+29),a
	jp	xpmp_update_ay_EN_done		
	xpmp_update_ay_EN_loop:
	ld	a,(ix+26)			; Which arpeggio macro are we using?
	dec	a
	add	a,a				; Each pointer is two bytes
	ld	e,a
	ld	bc,xpmp_EN_mac_loop_tbl
	ex	de,hl
	add	hl,bc				; HL = xpmp_EN_mac_loop_tbl + (enMac - 1)*2
	ld	a,(hl)				; Read low byte of pointer
	ld	(ix+27),a
	inc	hl
	ld	a,(hl)				; Read high byte of pointer
	ld	(ix+28),a
	ld	a,1
	ld	(ix+29),a			; Reset position
	ld	l,(ix+27)
	ld	h,(ix+28)
	ld	b,(hl)
	ld	a,(ix+8)
	add	a,b
	ld	(ix+8),a			; Reset note offset
	xpmp_update_ay_EN_done:
	.ENDIF
	
	.IFNDEF XPMP_EN2MAC_NOT_USED
	; Non-cumulative arpeggio
	ld 	a,(ix+30)
	cp	EFFECT_DISABLED
	jr 	z,xpmp_update_ay_EN2_done
	xpmp_update_ay_EN2:
	ld	a,1
	ld	(xpmp_freqChange),a		; Frequency has changed, but we haven't read a new note/rest yet
	ld	l,(ix+31)
	ld	h,(ix+32)
	ld 	d,0
	ld 	e,(ix+33)
	add 	hl,de				; Add macro position to pointer
	ld 	a,(hl)
	cp 	128				; If we read a value of 128 we should loop
	jr 	z,xpmp_update_ay_EN2_loop
	ld	(ix+8),a			; Number of semitones to offset the current note by
	inc	de				; Increase the position
	ld	a,e				
	ld	(ix+33),a
	jp	xpmp_update_ay_EN2_done		
	xpmp_update_ay_EN2_loop:
	ld	a,(ix+30)			; Which arpeggio macro are we using?
	dec	a
	add	a,a				; Each pointer is two bytes
	ld	e,a
	ld	bc,xpmp_EN_mac_loop_tbl
	ex	de,hl
	add	hl,bc				; HL = xpmp_EN_mac_loop_tbl + (en2Mac - 1)*2
	ld	a,(hl)				; Read low byte of pointer
	ld	(ix+31),a
	inc	hl
	ld	a,(hl)				; Read high byte of pointer
	ld	(ix+32),a
	ld	a,1
	ld	(ix+33),a			; Reset position
	ld	l,(ix+31)
	ld	h,(ix+32)
	ld	a,(hl)
	ld	(ix+8),a			; Reset note offset
	xpmp_update_ay_EN2_done:
	.ENDIF
	
	ld	a,(xpmp_chnum)
	cp	3
	jp	z,xpmp_update_ay_effects_done
	.IFNDEF XPMP_EPMAC_NOT_USED
	; Sweep macro
	ld 	a,(ix+34)
	cp	EFFECT_DISABLED
	jr 	z,xpmp_update_ay_EP_done
	xpmp_update_ay_EP:
	ld	a,1
	ld	(xpmp_freqChange),a		; Frequency has changed, but we haven't read a new note/rest yet
	ld	l,(ix+35)
	ld	h,(ix+36)
	ld 	d,0
	ld 	a,(ix+37)
	ld 	e,a
	add 	hl,de				; Add macro position to pointer
	ld 	a,(hl)
	cp 	128				; If we read a value of 128 we should loop
	jr 	z,xpmp_update_ay_EP_loop
	ld	b,a
	inc	de				; Increase the position
	ld	a,e				
	ld	(ix+37),a
	ld	e,b
	ld	d,0
	bit	7,b
	jr	z,xpmp_update_ay_pos_freq
	ld	d,$FF
	xpmp_update_ay_pos_freq:
	ld	l,(ix+16)
	ld	h,(ix+17)
	add	hl,de
	ld	(ix+16),l
	ld	(ix+17),h
	jp	xpmp_update_ay_EP_done		
	xpmp_update_ay_EP_loop:
	ld	a,(ix+34)			; Which sweep macro are we using?
	dec	a
	add	a,a				; Each pointer is two bytes
	ld	e,a
	ld	bc,xpmp_EP_mac_loop_tbl
	ex	de,hl
	add	hl,bc				; HL = xpmp_EP_mac_loop_tbl + (epMac - 1)*2
	ld	a,(hl)				; Read low byte of pointer
	ld	(ix+35),a
	inc	hl
	ld	a,(hl)				; Read high byte of pointer
	ld	(ix+36),a
	ld	a,1
	ld	(ix+37),a			; Reset position
	ld	l,(ix+35)
	ld	h,(ix+36)
	ld	e,(hl)
	ld	d,0
	bit	7,e
	jr	z,xpmp_update_ay_pos_freq_2
	ld	d,$FF
	xpmp_update_ay_pos_freq_2:
	ld	l,(ix+16)
	ld	h,(ix+17)
	add	hl,de
	ld	(ix+16),l
	ld	(ix+17),h
	xpmp_update_ay_EP_done:
	.ENDIF
	
	.IFNDEF XPMP_MPMAC_NOT_USED
	; Vibrato
	ld 	a,(ix+38)
	cp	EFFECT_DISABLED
	jr 	z,xpmp_update_ay_MP_done
	ld	a,(ix+41)
	dec	a
	jr 	nz,xpmp_update_ay_MP_done2
	xpmp_update_ay_MP:
	ld	a,1
	ld	(xpmp_freqChange),a		; Volume has changed
	ld	l,(ix+39)
	ld	h,(ix+40)
	ld	e,(ix+18) 			; Load the frequency offset from the latch, then negate the latch
	ld	(ix+16),e
	ld	e,(ix+19)
	ld	(ix+17),e
	and	a				; Clear carry
	ld 	a,(hl)				; Reload the vibrato delay
	ld	hl,0
	sbc	hl,de
	ld	(ix+18),l
	ld	(ix+19),h
	xpmp_update_ay_MP_done2:
	ld	(ix+41),a
	xpmp_update_ay_MP_done:
	.ENDIF

	xpmp_update_ay_effects_done:
	ld	a,(xpmp_freqChange)
	cp	0
	jp	nz,xpmp_update_ay_freq_change
	jp	xpmp_update_ay_set_vol

	ret	
	
.ENDIF


;######################################################################################################################

.IFDEF XPMP_USES_SCC

; Note / rest
xpmp_scc_cmd_00:
xpmp_scc_cmd_60:
	ld	hl,(xpmp_tempw)
xpmp_scc_cmd_00_2:
	ld	a,(ix+7)
	ld	(xpmp_lastNote),a
	ld	a,c
	and	$0F
	ld	(ix+7),a
	ld	a,c
	and	$F0
	cp	CMD_NOTE2
	jr	z,xpmp_scc_cmd_00_std_delay	
	ld	e,(ix+2)
	ld	d,(ix+3)
	inc	de
	inc	de
	ld	(ix+2),e
	ld	(ix+3),d
	inc	hl
	ld	a,(hl)
	bit	7,a
	jr	z,xpmp_scc_cmd_00_short_note
		inc	de
		ld	(ix+2),e
		ld	(ix+3),d
		inc	hl
		res	7,a
		ld	d,a
		srl	d
		rrc	a
		and	$80
		ld	e,(hl)
		or	e
		ld	e,a
		inc	hl
		ld	a,(ix+4)	
		add	a,(hl)
		ld	(ix+4),a		; Fractional part
		ld	hl,0 
		adc	hl,de
		ld	(ix+5),l		; Whole part
		ld	(ix+6),h
		jp 	xpmp_scc_cmd_00_got_delay
	xpmp_scc_cmd_00_short_note:
	ld	d,0
	ld	e,a
	inc	hl
	ld	a,(ix+4)	
	add	a,(hl)
	ld	(ix+4),a			; Fractional part
	ld	hl,0 
	adc	hl,de
	ret	z
	ld	(ix+5),l			; Whole part
	ld	(ix+6),h
	jp 	xpmp_scc_cmd_00_got_delay
	xpmp_scc_cmd_00_std_delay:		; Use delay set by last CMD_LEN
	ld	a,(ix+52)
	ld	b,a
	ld	a,(ix+4)
	add	a,b
	ld	(ix+4),a
	ld 	l,(ix+53)
	ld	h,(ix+54)
	ld	de,0
	adc	hl,de
	ret	z
	ld	(ix+5),l
	ld	(ix+6),h
	xpmp_scc_cmd_00_got_delay:
	ld	a,2
	ld	(xpmp_freqChange),a
	ld	a,(ix+7)
	cp	CMD_REST	
	ret	z				; If this was a rest command we can return now
	.IFNDEF XPMP_VMAC_NOT_USED
	ld	a,(ix+22)
	cp	EFFECT_DISABLED
	call	nz,xpmp_scc_reset_v_mac	; Reset effects as needed..
	.ENDIF
	.IFNDEF XPMP_ENMAC_NOT_USED
	ld	a,(ix+26)
	cp	EFFECT_DISABLED
	call	nz,xpmp_scc_reset_en_mac
	.ENDIF
	.IFNDEF XPMP_EN2MAC_NOT_USED
	ld	a,(ix+30)
	cp	EFFECT_DISABLED
	call	nz,xpmp_scc_reset_en2_mac
	.ENDIF
	.IFNDEF XPMP_MPMAC_NOT_USED
	ld	a,(ix+38)
	cp	EFFECT_DISABLED
	call	nz,xpmp_scc_reset_mp_mac
	.ENDIF
	.IFNDEF XPMP_EPMAC_NOT_USED
	ld	a,(ix+34)
	cp	EFFECT_DISABLED
	call	nz,xpmp_scc_reset_ep_mac
	.ENDIF
	ret
	
; Set octave
xpmp_scc_cmd_10:
	ld	a,c 
	and	$0F
	;sub	1				; Minimum octave is 1
	ld	b,a
	add	a,a
	add	a,a
	sla	b
	sla	b
	sla	b
	add	a,b				; A = (C & $0F) * 12
	ld	(ix+9),a
	ret
	
xpmp_scc_cmd_20:
	ret

; Set volume (short)
xpmp_scc_cmd_30:
	ld	a,c
	and	$0F
	ld	(ix+13),a
	ld	a,1
	ld	(xpmp_volChange),a		; Volume has changed
	ld	a,EFFECT_DISABLED
	ld	(ix+22),a			; Volume set overrides volume macros
	ret

; Octave up + note	
xpmp_scc_cmd_40:
	ld	hl,(xpmp_tempw)
	ld	a,(ix+9)
	add	a,12
	ld	(ix+9),a
	jp	xpmp_scc_cmd_00_2

; Octave down + note
xpmp_scc_cmd_50:
	ld	hl,(xpmp_tempw)
	ld	a,(ix+9)
	sub	12
	ld	(ix+9),a
	jp	xpmp_scc_cmd_00_2

;xpmp_scc_cmd_60:
xpmp_scc_cmd_70:
xpmp_scc_cmd_80:
	ret

; Turn off arpeggio macro
xpmp_scc_cmd_90:
	ld	a,c
	cp	CMD_JSR
	jr	z,xpmp_scc_cmd_90_jsr
	cp	CMD_RTS
	jr	z,xpmp_scc_cmd_90_rts
	cp	CMD_LEN
	jr	z,xpmp_scc_cmd_90_len
	
	ld	hl,(xpmp_tempw)
	ld	a,0
	ld	(ix+26),a
	ld	(ix+30),a
	ld	(ix+8),a
	ret

	; Jump to pattern
	xpmp_scc_cmd_90_jsr:
	ld	e,(ix+2)
	ld	d,(ix+3)
	inc	de
	ld	(ix+50),e
	ld	(ix+51),d
	ld	a,(ix+0)
	ld	(ix+48),a
	ld	a,(ix+1)
	ld	(ix+49),a
	ld	hl,(xpmp_tempw)
	inc	hl
	ld	a,(hl)
	ld	de,xpmp_pattern_tbl
	ld	h,0
	add	a,a
	ld	l,a
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	ld	(ix+0),e
	ld	(ix+1),d
	ld	a,$FF
	ld	(ix+2),a
	ld	(ix+3),a
	;bleh:
	;jr bleh
	ret
	
	; Return from pattern
	xpmp_scc_cmd_90_rts:
	ld	a,(ix+48)
	ld	(ix+0),a
	ld	a,(ix+49)
	ld	(ix+1),a
	ld	a,(ix+50)
	ld	(ix+2),a
	ld	a,(ix+51)
	ld	(ix+3),a
	ret

	xpmp_scc_cmd_90_len:
	ld	hl,(xpmp_tempw)
	ld	e,(ix+2)
	ld	d,(ix+3)
	inc	de
	inc	de
	ld	(ix+2),e
	ld	(ix+3),d
	inc	hl
	ld	a,(hl)
	bit	7,a
	jr	z,xpmp_scc_cmd_90_short_delay
		inc	de
		ld	(ix+2),e
		ld	(ix+3),d
		inc	hl
		res	7,a
		ld	d,a
		srl	d
		rrc	a
		and	$80
		ld	e,(hl)
		or	e
		ld	e,a
		inc	hl
		ld	a,(hl)
		ld	(ix+52),a	; Fractional part
		ld	(ix+53),e	; Whole part
		ld	(ix+54),d
		ret
	xpmp_scc_cmd_90_short_delay:
	ld	d,0
	ld	e,a
	inc	hl
	ld	a,(hl)
	ld	(ix+52),a	; Fractional part
	ld	(ix+53),e	; Whole part
	ld	(ix+54),d	; ...
	ret
	
xpmp_scc_cmd_A0:
xpmp_scc_cmd_B0:
xpmp_scc_cmd_C0:
xpmp_scc_cmd_D0:
	ret

; Callback
xpmp_scc_cmd_E0:
	ld	hl,(xpmp_tempw)
	inc	(ix+2)
	jr	nz,+
	inc	(ix+3)
	+:
	ld	a,c
	cp	CMD_CBOFF
	jr	z,xpmp_scc_cmd_E0_cboff
	cp	CMD_CBONCE
	jr	z,xpmp_scc_cmd_E0_cbonce
	cp	CMD_CBEVNT
	jr	z,xpmp_scc_cmd_E0_cbevnt
	cp	CMD_DETUNE
	jr	z,xpmp_scc_cmd_E0_detune
	cp	CMD_LDWAVE
	jr	z,xpmp_scc_cmd_E0_ldwave
	ret
	
	xpmp_scc_cmd_E0_cboff:
	ret
	
	xpmp_scc_cmd_E0_cbonce:
	ret
	
	; Every note
	xpmp_scc_cmd_E0_cbevnt:
	ret

	xpmp_scc_cmd_E0_detune:
	inc	hl
	ld	e,(hl)
	ld	d,0
	bit	7,e
	jr	z,xpmp_scc_cmd_E0_detune_pos
	ld	d,$FF
	xpmp_scc_cmd_E0_detune_pos:
	ld	(ix+20),e
	ld	(ix+21),d
	ret

	; Load waveform
	xpmp_scc_cmd_E0_ldwave:
	inc	hl
	ld	a,(hl)
	dec	a
	ld	e,a
	ld	d,0
	sla	e
	rl	d
	sla	e
	rl	d
	sla	e
	rl	d
	sla	e
	rl	d
	sla	e
	rl	d
	ld 	hl,xpmp_waveform_data
	add	hl,de
	ld	a,(xpmp_chnum)
	sla	a
	sla	a
	sla	a
	sla	a
	sla	a
	ld	e,a
	ld	d,$98
	ld	bc,32
	ldir
	ret
	
	
xpmp_scc_cmd_F0:
	ld	hl,(xpmp_tempw)
	inc	(ix+2)
	jr	nz,+
	inc	(ix+3)
	+:	
	; Initialize volume macro	
	ld	a,c

	.IFNDEF XPMP_VMAC_NOT_USED
	cp	CMD_VOLMAC
	;.IF \1 < 3
	jr	nz,xpmp_scc_cmd_F0_check_VIBMAC
	;.ELSE
	;jr	nz,xpmp_\1_cmd_F0_check_JMP
	;.ENDIF
	inc	hl
	ld	a,(hl)
	ld	(ix+22),a
	xpmp_scc_reset_v_mac:
	dec	a
	add	a,a
	ld	hl,xpmp_v_mac_tbl
	ld	d,0
	ld	e,a
	add	hl,de
	ld	a,(hl)	
	ld	(ix+23),a
	inc	hl
	ld	a,(hl)
	ld	(ix+24),a
	ld	l,(ix+23)
	ld	h,(ix+24)
	ld	a,(hl)
	ld	(ix+13),a
	ld	a,1
	ld	(xpmp_volChange),a	
	ld	a,1
	ld	(ix+25),a
	ret
	.ENDIF
	
	;.IF \1 < 3
	xpmp_scc_cmd_F0_check_VIBMAC:
	.IFNDEF XPMP_MPMAC_NOT_USED
	; Initialize vibrato macro
	cp	CMD_VIBMAC
	jr	nz,xpmp_scc_cmd_F0_check_SWPMAC
	inc	hl
	ld	a,(hl)
	cp	EFFECT_DISABLED
	jr	z,xpmp_scc_cmd_F0_disable_VIBMAC
	ld	(ix+38),a
	xpmp_scc_reset_mp_mac:
	dec	a
	add	a,a
	ld	hl,xpmp_MP_mac_tbl
	ld	d,0
	ld	e,a
	add	hl,de
	ld	a,(hl)
	ld	(ix+39),a
	inc	hl
	ld	a,(hl)
	ld	(ix+40),a
	ld	l,(ix+39)
	ld	h,(ix+40)
	ld	a,(hl)
	ld	(ix+41),a
	inc	hl
	ld	(ix+39),l
	ld	(ix+40),h
	inc	hl
	ld	a,(hl)
	ld	(ix+18),a
	ld	a,0
	ld	(ix+19),a
	ld	(ix+16),a
	ld	(ix+17),a
	ret
	xpmp_scc_cmd_F0_disable_VIBMAC:
	ld	(ix+38),a
	ld	(ix+16),a
	ld	(ix+17),a
	ret
	.ENDIF
	
	; Initialize sweep macro
	xpmp_scc_cmd_F0_check_SWPMAC:
	.IFNDEF XPMP_EPMAC_NOT_USED
	cp	CMD_SWPMAC
	jr	nz,xpmp_scc_cmd_F0_check_JMP
	inc	hl
	ld	a,(hl)
	ld	(ix+34),a
	cp	EFFECT_DISABLED
	jr	z,xpmp_scc_cmd_F0_disable_SWPMAC	
	xpmp_scc_reset_ep_mac:
	dec	a
	add	a,a
	ld	hl,xpmp_EP_mac_tbl
	ld	d,0
	ld	e,a
	add	hl,de
	ld	a,(hl)	
	ld	(ix+35),a
	inc	hl
	ld	a,(hl)
	ld	(ix+36),a
	ld	l,(ix+35)
	ld	h,(ix+36)
	ld	a,1
	ld	(ix+37),a
	dec	a
	ld	(ix+17),a
	ld	a,(hl)
	ld	(ix+16),a
	bit	7,a
	ret	z
	ld	a,$FF
	ld	(ix+17),a
	ret
	xpmp_scc_cmd_F0_disable_SWPMAC:
	ld	(ix+34),a
	ld	(ix+16),a
	ld	(ix+17),a
	ret
	.ENDIF
	
	; Jump
	xpmp_scc_cmd_F0_check_JMP:
	cp	CMD_JMP
	jr	nz,xpmp_scc_cmd_F0_check_LOPCNT
	inc	hl
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	dec	de				; dataPos will be increased after the return, so we decrease it here
	ld	(ix+2),e
	ld	(ix+3),d
	ret

	; Set loop count
	xpmp_scc_cmd_F0_check_LOPCNT:
	cp	CMD_LOPCNT
	jr	nz,xpmp_scc_cmd_F0_check_DJNZ
	inc	hl
	ld	a,(hl)
	ld	l,(ix+44)
	ld	h,(ix+45)
	inc	hl
	ld	(hl),a
	ld	(ix+44),l
	ld	(ix+45),h
	ret

	; Decrease and jump if not zero
	xpmp_scc_cmd_F0_check_DJNZ:
	cp	CMD_DJNZ
	jr	nz,xpmp_scc_cmd_F0_check_APMAC2
	ld	l,(ix+44)
	ld	h,(ix+45)
	dec	(hl)
	jr	z,xpmp_scc_cmd_F0_DJNZ_Z	; Check if the counter has reached zero
	ld	hl,(xpmp_tempw)
	inc	hl
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	dec	de				; dataPos will be increased after the return, so we decrease it here
	ld	(ix+2),e
	ld	(ix+3),d
	ret
	xpmp_scc_cmd_F0_DJNZ_Z:
	dec	hl
	ld	(ix+44),l
	ld	(ix+45),h
	inc	(ix+2)
	jr	nz,+
	inc	(ix+3)
	+:	
	ret
	
	; Initialize non-cumulative arpeggio macro
	xpmp_scc_cmd_F0_check_APMAC2:
	.IFNDEF XPMP_EN2MAC_NOT_USED
	cp	CMD_APMAC2
	jr	nz,xpmp_scc_cmd_F0_check_ARPMAC
	inc	hl
	ld	a,(hl)
	ld	(ix+30),a
	xpmp_scc_reset_en2_mac:
	dec	a
	add	a,a
	ld	hl,xpmp_EN_mac_tbl
	ld	d,0
	ld	e,a
	add	hl,de
	ld	a,(hl)	
	ld	(ix+31),a
	inc	hl
	ld	a,(hl)
	ld	(ix+32),a
	ld	l,(ix+31)
	ld	h,(ix+32)
	ld	a,(hl)
	ld	(ix+8),a
	ld	a,1
	ld	(ix+33),a
	dec	a
	ld	(ix+26),a
	ret
	.ENDIF
	
	; Initialize non-cumulative arpeggio macro
	xpmp_scc_cmd_F0_check_ARPMAC:
	.IFNDEF XPMP_ENMAC_NOT_USED
	cp	CMD_ARPMAC
	jr	nz,xpmp_scc_cmd_F0_check_PANMAC
	inc	hl
	ld	a,(hl)
	ld	(ix+26),a
	xpmp_scc_reset_en_mac:
	dec	a
	add	a,a
	ld	hl,xpmp_EN_mac_tbl
	ld	d,0
	ld	e,a
	add	hl,de
	ld	a,(hl)	
	ld	(ix+27),a
	inc	hl
	ld	a,(hl)
	ld	(ix+28),a
	ld	l,(ix+27)
	ld	h,(ix+28)
	ld	a,(hl)
	ld	(ix+8),a
	ld	a,1
	ld	(ix+29),a
	dec	a
	ld	(ix+30),a
	ret
	.ENDIF
	
	xpmp_scc_cmd_F0_check_PANMAC:
	cp	CMD_PANMAC
	jr	nz,xpmp_scc_cmd_F0_check_END
	inc	hl
	;ld	a,(hl)
	ld	a,0
	;ld	(xpmp_channel\1.csMac),a
	ret
	
	xpmp_scc_cmd_F0_check_END:
	cp	CMD_END
	jr	nz,xpmp_scc_cmd_F0_not_found
	ld	a,CMD_END
	ld	(ix+7),a			; Playback of this channel should end
	ld	a,2
	ld	(xpmp_freqChange),a		; The command-reading loop should exit	
	ret

	xpmp_scc_cmd_F0_not_found:
	ret
	
	

xpmp_update_scc:
	ld	(xpmp_chnum),a
	add	a,a
	ld	e,a
	ld	d,0
	ld	hl,xpmp_scc_channel_ptr_tbl
	add	hl,de
	ld	a,(hl)
	ld	(xpmp_tempw),a
	inc	hl
	ld	a,(hl)
	ld	(xpmp_tempw+1),a
	ld	ix,(xpmp_tempw)
	
	ld	a,0
	ld	(xpmp_freqChange),a
	ld	(xpmp_volChange),a
	
	ld	a,(ix+7)
	cp	CMD_END
	ret	z				; Playback has ended for this channel - all processing should be skipped
	
	ld 	l,(ix+5)			; Decrement the whole part of the delay and check if it has reached zero
	ld	h,(ix+6)
	dec	hl
	ld	a,h
	or	l
	jp 	nz,xpmp_update_scc_effects	
	
	; Loop here until a note/rest or END command is read (signaled by xpmp_freqChange == 2)
	xpmp_update_scc_read_cmd:
	ld	l,(ix+0)
	ld	h,(ix+1)
	ld	e,(ix+2)
	ld	d,(ix+3)
	add 	hl,de
	ld 	c,(hl)
	ld	(xpmp_tempw),hl			; Store HL for later use
	ld	a,c
	srl	a
	srl	a
	srl	a
	res	0,a				; A = (C>>3)&~1 = (C>>4)<<1
	ld	l,a
	ld	h,0
	ld	de,xpmp_scc_jump_tbl	
	add	hl,de
	ld	e,(hl)				; HL = jump_tbl + (command >> 4)
	inc	hl
	ld	d,(hl)
	ex	de,hl
	call	xpmp_call_hl

	inc	(ix+2)
	jr	nz,+
	inc	(ix+3)
	+:
	
	ld	a,(xpmp_freqChange)
	cp	2
	jr	z,xpmp_update_scc_freq_change
	jp 	xpmp_update_scc_read_cmd
	
	xpmp_update_scc_freq_change:
	;ret
	ld	a,(ix+7)
	cp	CMD_REST
	jp	z,xpmp_update_scc_rest
	cp	CMD_END
	jp	z,xpmp_update_scc_rest
	ld	b,a
	ld	a,(ix+8)
	add	a,b
	ld	b,a
	ld	a,(ix+9)
	add	a,b
	ld	hl,ay_freq_tbl
	ld	d,0
	add	a,a
	ld	e,a
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	ex	de,hl
	ld	e,(ix+16)
	ld	d,(ix+17)
	and	a
	sbc	hl,de
	ld	e,(ix+20)
	ld	d,(ix+21)
	and	a
	sbc	hl,de
	JL_IMM16 $0FFF,xpmp_update_scc_lb_ok
	ld	hl,(ay_freq_tbl+18)
	jp	xpmp_update_scc_freq_ok
	xpmp_update_scc_lb_ok:
	JGE_IMM16 $001C,xpmp_update_scc_freq_ok
	ld	hl,$001C
	xpmp_update_scc_freq_ok:
	ex	de,hl
	ld	a,(xpmp_chnum)
	add	a,a
	or	$80
	ld	l,a
	ld	h,$98
	ld	(hl),e
	inc 	hl
	ld	(hl),d
	
	ld	a,(xpmp_lastNote)
	cp	CMD_REST
	jr	nz,xpmp_update_scc_set_vol2
	jp	xpmp_update_scc_set_vol3

	xpmp_update_scc_set_vol:
	ld	a,(ix+7)
	cp	CMD_REST
	jr	z,xpmp_update_scc_rest
	xpmp_update_scc_set_vol2:
	; Update the volume if it has changed
	ld	a,(xpmp_volChange)
	cp	0
	ret	z
	xpmp_update_scc_set_vol3:
	ld	a,(xpmp_chnum)
	add	a,$8A
	ld	l,a
	ld	h,$98
	ld	a,(ix+13)
	ld	(hl),a
	xpmp_update_scc_no_vol_change:
	ret
	
	; Mute the channel
	xpmp_update_scc_rest:
	ld	a,(xpmp_chnum)
	add	a,$8A
	ld	l,a
	ld	h,$98
	ld	a,0
	ld	(hl),a
	ret
	
	xpmp_update_scc_effects:
	ld 	(ix+5),l
	ld	(ix+6),h

	.IFNDEF XPMP_VMAC_NOT_USED
	; Volume macro
	ld 	a,(ix+22)
	cp 	EFFECT_DISABLED
	jr 	z,xpmp_update_scc_v_done 
	xpmp_update_scc_v:
	ld 	l,(ix+23)
	ld	h,(ix+24)
	ld	a,1
	ld	(xpmp_volChange),a
	ld 	d,0
	ld 	a,(ix+25)
	ld 	e,a
	add 	hl,de				; Add macro position to pointer
	ld 	a,(hl)
	cp 	128				; If we read a value of 128 we should loop
	jr 	z,xpmp_update_scc_v_loop
	ld	(ix+13),a		 	; Set a new volume
	inc	de				; Increase the position
	ld	a,e
	ld	(ix+25),a
	jp	xpmp_update_scc_v_done
	xpmp_update_scc_v_loop:
	ld	a,(ix+22)			; Which volume macro are we using?
	dec	a
	ld	e,a
	sla	e				; Each pointer is two bytes
	ld	bc,xpmp_v_mac_loop_tbl
	;ld	hl,(xpmp_vMacPtr)
	ex	de,hl
	add	hl,bc 				; HL = xpmp_vMac_loop_tbl + (vMac - 1)*2
	ld	a,(hl)				; Read low byte of pointer
	ld	(ix+23),a			; Store in xpmp_\1_vMac_ptr
	;inc 	de	
	inc	hl
	ld	a,(hl)				; Read high byte of pointer
	ld	(ix+24),a
	ld	a,1
	ld	(ix+25),a
	ld	l,(ix+23)
	ld	h,(ix+24)
	ld	a,(hl)
	ld	(ix+13),a
	xpmp_update_scc_v_done:
	.ENDIF
	
	.IFNDEF XPMP_ENMAC_NOT_USED
	; Cumulative arpeggio
	ld 	a,(ix+26)
	cp	EFFECT_DISABLED
	jr 	z,xpmp_update_scc_EN_done
	xpmp_update_scc_EN:
	ld	a,1
	ld	(xpmp_freqChange),a		; Frequency has changed, but we haven't read a new note/rest yet
	ld	l,(ix+27)
	ld	h,(ix+28)
	ld 	d,0
	ld 	e,(ix+29)
	add 	hl,de				; Add macro position to pointer
	ld 	a,(hl)
	cp 	128				; If we read a value of 128 we should loop
	jr 	z,xpmp_update_scc_EN_loop
	ld	b,a
	ld	a,(ix+8)
	add	a,b
	ld	(ix+8),a			; Number of semitones to offset the current note by
	inc	de				; Increase the position
	ld	a,e				
	ld	(ix+29),a
	jp	xpmp_update_scc_EN_done		
	xpmp_update_scc_EN_loop:
	ld	a,(ix+26)			; Which arpeggio macro are we using?
	dec	a
	add	a,a				; Each pointer is two bytes
	ld	e,a
	;ld	hl,(xpmp_enMacPtr)
	ld	bc,xpmp_EN_mac_loop_tbl
	ex	de,hl
	add	hl,bc				; HL = xpmp_EN_mac_loop_tbl + (enMac - 1)*2
	ld	a,(hl)				; Read low byte of pointer
	ld	(ix+27),a
	;inc 	de
	inc	hl
	ld	a,(hl)				; Read high byte of pointer
	ld	(ix+28),a
	ld	a,1
	ld	(ix+29),a			; Reset position
	ld	l,(ix+27)
	ld	h,(ix+28)
	ld	b,(hl)
	ld	a,(ix+8)
	add	a,b
	ld	(ix+8),a			; Reset note offset
	xpmp_update_scc_EN_done:
	.ENDIF
	
	.IFNDEF XPMP_EN2MAC_NOT_USED
	; Non-cumulative arpeggio
	ld 	a,(ix+30)
	cp	EFFECT_DISABLED
	jr 	z,xpmp_update_scc_EN2_done
	xpmp_update_scc_EN2:
	ld	a,1
	ld	(xpmp_freqChange),a		; Frequency has changed, but we haven't read a new note/rest yet
	ld	l,(ix+31)
	ld	h,(ix+32)
	ld 	d,0
	ld 	e,(ix+33)
	add 	hl,de				; Add macro position to pointer
	ld 	a,(hl)
	cp 	128				; If we read a value of 128 we should loop
	jr 	z,xpmp_update_scc_EN2_loop
	ld	(ix+8),a			; Number of semitones to offset the current note by
	inc	de				; Increase the position
	ld	a,e				
	ld	(ix+33),a
	jp	xpmp_update_scc_EN2_done		
	xpmp_update_scc_EN2_loop:
	ld	a,(ix+30)			; Which arpeggio macro are we using?
	dec	a
	add	a,a				; Each pointer is two bytes
	ld	e,a
	;ld	hl,(xpmp_en2MacPtr)
	ld	bc,xpmp_EN_mac_loop_tbl
	ex	de,hl
	add	hl,bc				; HL = xpmp_EN_mac_loop_tbl + (en2Mac - 1)*2
	ld	a,(hl)				; Read low byte of pointer
	ld	(ix+31),a
	;inc 	de
	inc	hl
	ld	a,(hl)				; Read high byte of pointer
	ld	(ix+32),a
	ld	a,1
	ld	(ix+33),a			; Reset position
	ld	l,(ix+31)
	ld	h,(ix+32)
	ld	a,(hl)
	ld	(ix+8),a			; Reset note offset
	xpmp_update_scc_EN2_done:
	.ENDIF
	
	ld	a,(xpmp_chnum)
	cp	3
	jp	z,xpmp_update_scc_effects_done
	.IFNDEF XPMP_EPMAC_NOT_USED
	; Sweep macro
	ld 	a,(ix+34)
	cp	EFFECT_DISABLED
	jr 	z,xpmp_update_scc_EP_done
	xpmp_update_scc_EP:
	ld	a,1
	ld	(xpmp_freqChange),a		; Frequency has changed, but we haven't read a new note/rest yet
	ld	l,(ix+35)
	ld	h,(ix+36)
	ld 	d,0
	ld 	a,(ix+37)
	ld 	e,a
	add 	hl,de				; Add macro position to pointer
	ld 	a,(hl)
	cp 	128				; If we read a value of 128 we should loop
	jr 	z,xpmp_update_scc_EP_loop
	ld	b,a
	inc	de				; Increase the position
	ld	a,e				
	ld	(ix+37),a
	ld	e,b
	ld	d,0
	bit	7,b
	jr	z,xpmp_update_scc_pos_freq
	ld	d,$FF
	xpmp_update_scc_pos_freq:
	ld	l,(ix+16)
	ld	h,(ix+17)
	add	hl,de
	ld	(ix+16),l
	ld	(ix+17),h
	jp	xpmp_update_scc_EP_done		
	xpmp_update_scc_EP_loop:
	ld	a,(ix+34)			; Which sweep macro are we using?
	dec	a
	add	a,a				; Each pointer is two bytes
	ld	e,a
	;ld	hl,(xpmp_epMacPtr)
	ld	bc,xpmp_EP_mac_loop_tbl
	ex	de,hl
	add	hl,bc				; HL = xpmp_EP_mac_loop_tbl + (epMac - 1)*2
	ld	a,(hl)				; Read low byte of pointer
	ld	(ix+35),a
	;inc 	de
	inc	hl
	ld	a,(hl)				; Read high byte of pointer
	ld	(ix+36),a
	ld	a,1
	ld	(ix+37),a			; Reset position
	ld	l,(ix+35)
	ld	h,(ix+36)
	ld	e,(hl)
	ld	d,0
	bit	7,e
	jr	z,xpmp_update_scc_pos_freq_2
	ld	d,$FF
	xpmp_update_scc_pos_freq_2:
	ld	l,(ix+16)
	ld	h,(ix+17)
	add	hl,de
	ld	(ix+16),l
	ld	(ix+17),h
	xpmp_update_scc_EP_done:
	.ENDIF
	
	.IFNDEF XPMP_MPMAC_NOT_USED
	; Vibrato
	ld 	a,(ix+38)
	cp	EFFECT_DISABLED
	jr 	z,xpmp_update_scc_MP_done
	ld	a,(ix+41)
	dec	a
	jr 	nz,xpmp_update_scc_MP_done2
	xpmp_update_scc_MP:
	ld	a,1
	ld	(xpmp_freqChange),a		; Volume has changed
	ld	l,(ix+39)
	ld	h,(ix+40)
	ld	e,(ix+18) 			; Load the frequency offset from the latch, then negate the latch
	ld	(ix+16),e
	ld	e,(ix+19)
	ld	(ix+17),e
	and	a				; Clear carry
	ld 	a,(hl)				; Reload the vibrato delay
	ld	hl,0
	sbc	hl,de
	ld	(ix+18),l
	ld	(ix+19),h
	xpmp_update_scc_MP_done2:
	ld	(ix+41),a
	xpmp_update_scc_MP_done:
	.ENDIF

	xpmp_update_scc_effects_done:
	ld	a,(xpmp_freqChange)
	cp	0
	jp	nz,xpmp_update_scc_freq_change
	jp	xpmp_update_scc_set_vol

	ret	
	
.ENDIF


;######################################################################################################################


.IFDEF XPMP_ENABLE_CHANNEL_A
 XPMP_COMMANDS 0
 XPMP_UPDATE_FUNC 0
.ENDIF
.IFDEF XPMP_ENABLE_CHANNEL_B
 XPMP_COMMANDS 1
 XPMP_UPDATE_FUNC 1
.ENDIF
.IFDEF XPMP_ENABLE_CHANNEL_C
 XPMP_COMMANDS 2
 XPMP_UPDATE_FUNC 2
.ENDIF
.IFDEF XPMP_ENABLE_CHANNEL_D
 XPMP_COMMANDS 3
 XPMP_UPDATE_FUNC 3
.ENDIF


xpmp_update:
.IFDEF XPMP_ENABLE_CHANNEL_A
	call xpmp_0_update
.ENDIF
.IFDEF XPMP_ENABLE_CHANNEL_B
	call xpmp_1_update
.ENDIF
.IFDEF XPMP_ENABLE_CHANNEL_C
	call xpmp_2_update
.ENDIF
.IFDEF XPMP_ENABLE_CHANNEL_D
	call xpmp_3_update
.ENDIF
.IFDEF XPMP_ENABLE_CHANNEL_E
	ld	a,0
	call 	xpmp_update_ay
.ENDIF
.IFDEF XPMP_ENABLE_CHANNEL_F
	ld	a,1
	call 	xpmp_update_ay
.ENDIF
.IFDEF XPMP_ENABLE_CHANNEL_G
	ld	a,2
	call 	xpmp_update_ay
.ENDIF
.IFDEF XPMP_ENABLE_CHANNEL_H
	ld	a,0
	call 	xpmp_update_scc
.ENDIF
.IFDEF XPMP_ENABLE_CHANNEL_I
	ld	a,1
	call 	xpmp_update_scc
.ENDIF
.IFDEF XPMP_ENABLE_CHANNEL_J
	ld	a,2
	call 	xpmp_update_scc
.ENDIF
.IFDEF XPMP_ENABLE_CHANNEL_K
	ld	a,3
	call 	xpmp_update_scc
.ENDIF

ret
	

.IFDEF XPMP_USES_AY
xpmp_ay_channel_ptr_tbl:
.dw xpmp_channel4
.dw xpmp_channel5
.dw xpmp_channel6

xpmp_ay_jump_tbl:
.dw xpmp_ay_cmd_00
.dw xpmp_ay_cmd_10
.dw xpmp_ay_cmd_20
.dw xpmp_ay_cmd_30
.dw xpmp_ay_cmd_40
.dw xpmp_ay_cmd_50
.dw xpmp_ay_cmd_60
.dw xpmp_ay_cmd_70
.dw xpmp_ay_cmd_80
.dw xpmp_ay_cmd_90
.dw xpmp_ay_cmd_A0
.dw xpmp_ay_cmd_B0
.dw xpmp_ay_cmd_C0
.dw xpmp_ay_cmd_D0
.dw xpmp_ay_cmd_E0
.dw xpmp_ay_cmd_F0
.ENDIF


.IFDEF XPMP_USES_SCC
xpmp_scc_channel_ptr_tbl:
.dw xpmp_channel7
.dw xpmp_channel8
.dw xpmp_channel9
.dw xpmp_channel10


xpmp_scc_jump_tbl:
.dw xpmp_scc_cmd_00
.dw xpmp_scc_cmd_10
.dw xpmp_scc_cmd_20
.dw xpmp_scc_cmd_30
.dw xpmp_scc_cmd_40
.dw xpmp_scc_cmd_50
.dw xpmp_scc_cmd_60
.dw xpmp_scc_cmd_70
.dw xpmp_scc_cmd_80
.dw xpmp_scc_cmd_90
.dw xpmp_scc_cmd_A0
.dw xpmp_scc_cmd_B0
.dw xpmp_scc_cmd_C0
.dw xpmp_scc_cmd_D0
.dw xpmp_scc_cmd_E0
.dw xpmp_scc_cmd_F0
.ENDIF


.MACRO XPMP_JUMP_TABLE
xpmp_\1_jump_tbl:
.dw xpmp_\1_cmd_00
.dw xpmp_\1_cmd_10
.dw xpmp_\1_cmd_20
.dw xpmp_\1_cmd_30
.dw xpmp_\1_cmd_40
.dw xpmp_\1_cmd_50
.dw xpmp_\1_cmd_60
.dw xpmp_\1_cmd_70
.dw xpmp_\1_cmd_80
.dw xpmp_\1_cmd_90
.dw xpmp_\1_cmd_A0
.dw xpmp_\1_cmd_B0
.dw xpmp_\1_cmd_C0
.dw xpmp_\1_cmd_D0
.dw xpmp_\1_cmd_E0
.dw xpmp_\1_cmd_F0
.ENDM


.IFDEF XPMP_ENABLE_CHANNEL_A
 XPMP_JUMP_TABLE 0
.ENDIF
.IFDEF XPMP_ENABLE_CHANNEL_B
 XPMP_JUMP_TABLE 1
.ENDIF
.IFDEF XPMP_ENABLE_CHANNEL_C
 XPMP_JUMP_TABLE 2
.ENDIF
.IFDEF XPMP_ENABLE_CHANNEL_D
 XPMP_JUMP_TABLE 3
.ENDIF


; For AY3-8910 and Konami SCC
ay_freq_tbl:
.dw 6840, 6457, 6094, 5752, 5429, 5124, 4837, 4565, 4309, 4067, 3839, 3623 
.dw 3420, 3228, 3047, 2876, 2714, 2562, 2418, 2282, 2154, 2033, 1919, 1811 
.dw 1710, 1614, 1523, 1438, 1357, 1281, 1209, 1141, 1077, 1016, 959, 905 
.dw 855, 807, 761, 719, 678, 640, 604, 570, 538, 508, 479, 452 
.dw 427, 403, 380, 359, 339, 320, 302, 285, 269, 254, 239, 226 
.dw 213, 201, 190, 179, 169, 160, 151, 142, 134, 127, 119, 113 
.dw 106, 100, 95, 89, 84, 80, 75, 71, 67, 63, 59, 56 
.dw 53,   50, 47, 44, 42, 40, 37, 35, 33, 31, 29, 28 

.IFDEF XPMP_USES_SN76489
xpmp_freq_tbl:
.IFDEF XPMP_50_HZ
.IFDEF XPMP_TUNE_SMS
.dw $02A9,$0249,$01EF,$019A,$0149,$00FD,$00B5,$0072,$0032,$03F6,$03BD,$0387
.dw $0354,$0324,$02F7,$02CD,$02A4,$027E,$025A,$0239,$0219,$01FB,$01DE,$01C3
.dw $01AA,$0192,$017B,$0166,$0152,$013F,$012D,$011C,$010C,$00FD,$00EF,$00E1
.dw $00D5,$00C9,$00BD,$00B3,$00A9,$009F,$0096,$008E,$0086,$007E,$0077,$0070
.dw $006A,$0064,$005E,$0059,$0054,$004F,$004B,$0047,$0043,$003F,$003B,$0038
.dw $0035,$0032,$002F,$002C,$002A,$0027,$0025,$0023,$0021,$001F,$001D,$001C
.ELSE
.dw $029E,$023F,$01E5,$0191,$0141,$00F5,$00AE,$006B,$002B,$03EF,$03B7,$0381
.dw $034F,$031F,$02F2,$02C8,$02A0,$027A,$0257,$0235,$0215,$01F7,$01DB,$01C0
.dw $01A7,$018F,$0179,$0164,$0150,$013D,$012B,$011A,$010A,$00FB,$00ED,$00E0
.dw $00D3,$00C7,$00BC,$00B2,$00A8,$009E,$0095,$008D,$0085,$007D,$0076,$0070
.dw $0069,$0063,$005E,$0059,$0054,$004F,$004A,$0046,$0042,$003E,$003B,$0038
.dw $0034,$0031,$002F,$002C,$002A,$0027,$0025,$0023,$0021,$001F,$001D,$001C
.ENDIF
.ELSE
.IFDEF XPMP_TUNE_SMS
.dw $02B9,$0258,$01FD,$01A7,$0156,$0109,$00C0,$007C,$003C,$03FF,$03C5,$038F
.dw $035C,$032C,$02FE,$02D3,$02AB,$0284,$0260,$023E,$021E,$01FF,$01E2,$01C7
.dw $01AE,$0196,$017F,$0169,$0155,$0142,$0130,$011F,$010F,$00FF,$00F1,$00E3
.dw $00D7,$00CB,$00BF,$00B4,$00AA,$00A1,$0098,$008F,$0087,$007F,$0078,$0071
.dw $006B,$0065,$005F,$005A,$0055,$0050,$004C,$0047,$0043,$003F,$003C,$0038
.dw $0035,$0032,$002F,$002D,$002A,$0028,$0026,$0023,$0021,$001F,$001E,$001C
.ELSE
.dw $02AE,$024E,$01F3,$019E,$014D,$0101,$00B9,$0075,$0035,$03F8,$03BF,$0389
.dw $0357,$0327,$02F9,$02CF,$02A6,$0280,$025C,$023A,$021A,$01FC,$01DF,$01C4
.dw $01AB,$0193,$017C,$0167,$0153,$0140,$012E,$011D,$010D,$00FE,$00EF,$00E2
.dw $00D5,$00C9,$00BE,$00B3,$00A9,$00A0,$0097,$008E,$0086,$007F,$0077,$0071
.dw $006A,$0064,$005F,$0059,$0054,$0050,$004B,$0047,$0043,$003F,$003B,$0038
.dw $0035,$0032,$002F,$002C,$002A,$0028,$0025,$0023,$0021,$001F,$001D,$001C
.ENDIF
.ENDIF
.ENDIF
			


	